// -------------------------------------------------------------------------------
// 
// 		cwCu		}XNwb_t@C
// 
// 				Ver 3.11d
// 
// -------------------------------------------------------------------------------

#ifndef __DXMASK_H__
#define __DXMASK_H__

#include "DxCompileConfig.h"

#ifndef DX_NON_MASK

// CN[h ------------------------------------------------------------------
#include "DxLib.h"
#include "DxStatic.h"
#include "DxGraphicsAPI.h"
#include "DxMemImg.h"
#include "DxHandle.h"

namespace DxLib
{

// }N` --------------------------------------------------------------------

// \̒` --------------------------------------------------------------------

// }XNf[^p\
struct MASKDATA
{
	HANDLEINFO				HandleInfo ;							// nhʏ

	BYTE					*SrcData ;								// }XN\[Xf[^
	int						SrcDataPitch ;							// \[Xf[^sb`
	int						MaskWidth, MaskHeight ;					// }XN̕ƍ
	int						ValidFlag ;								// LtO
	int						TransMode ;								// ߐF[h
} ;

// }XNf[^Ǘp\
struct MASKMANAGEDATA
{
	int						InitializeFlag ;						// tO

	int						MaskBufferSizeX, MaskBufferSizeY ;		// }XNf[^obt@̃TCY
	BYTE					*MaskBuffer ;							// }XNf[^obt@
	int						MaskBufferPitch ;						// }XNf[^obt@̃sb`

	int						MaskReverseEffectFlag ;					// }XN̐lɑ΂ʂt]
	int						FullScreenMaskUpdateFlag ;				// Sʃ}XNXVsĂ邩̃tO
	int						CreateMaskFlag ;						// }XNT[tFX쐬Ă邩ÃtO
	int						MaskUseFlag ;							// }XNgp邩AtO
	int						MaskValidFlag ;							// MaskUseFlag  CreateMaskFlag  & 

	int						MaskBeginFunctionCount ;				// }XNgp`̑OɌĂԊ֐Ă΂ꂽ

	int						ValidMaskDrawMemImg ;					// MaskDrawMemImg LǂÃtO
	MEMIMG					MaskDrawMemImg ;						// }XNgp̕`T[tFX̑ MEMIMG

	// DirectX o[Wˑ`
	int						MaskTextureSizeX, MaskTextureSizeY ;	// }XNeNX`̃TCY
	DX_DIRECT3DTEXTURE9		*MaskImageTexture ;						// }XNC[WeNX`
	DX_DIRECT3DTEXTURE9		*MaskScreenTexture ;					// }XNXN[eNX`
	DX_DIRECT3DSURFACE9		*MaskScreenSurface ;					// }XNXN[T[tFX

} ;

// e[u-----------------------------------------------------------------------

// ϐ錾 --------------------------------------------------------------

// }XN֌W̏
extern MASKMANAGEDATA MaskManageData ;


// ֐vg^Cv錾-----------------------------------------------------------

// DxMask.cpp ֘A
extern	int			InitializeMask( void ) ;																				// }XN̏
extern	int			TerminateMask( void ) ;																					// }XŇn

extern	int			ReleaseMaskSurface( void ) ;																			// }XNXN[ꎞ폜
extern	int			ReCreateMaskSurface( void ) ;																			// }XNXN[𕜋
extern	int			CreateMaskScreenFunction( int MaskSurfaceFlag, int Width, int Height ) ;									// }XNXN[쐬֐
extern	int			SetGraphToMask( RECT MaskRect, DX_DIRECTDRAWSURFACE7 *SrcSurface, BASEIMAGE *SrcImage ) ;				// }XNf[^T[tFXɃOtBbN[h
extern	int			OutGraphToMask( RECT MaskRect, DX_DIRECTDRAWSURFACE7 *DestSurface, BASEIMAGE *DestImage ) ;				// }XLOsĎwT[tFXɓ]
extern	int			CreateMaskOn2D( int DrawPointX, int DrawPointY, int DestWidth, int DestHeight, void *DestBufP ,
								   int DestPitch, int DestBitDepth, int SrcWidth, int SrcHeight, void *SrcData ) ;			// }XNp^[̍쐬

extern	int			CreateMaskSurface( BYTE **MaskBuffer, int *BufferPitch, int Width, int Height, int *TransModeP ) ;		// }XNT[tFX̍쐬

extern	int			MaskDrawBeginFunction( RECT Rect ) ;																	// }XNgp`̑OɌĂԊ֐
extern	int			MaskDrawAfterFunction( RECT Rect ) ;																	// }XNgp`̌ɌĂԊ֐

extern	int			InitializeMaskHandle( HANDLEINFO *HandleInfo ) ;														// }XNnh̏
extern	int			TerminateMaskHandle( HANDLEINFO *HandleInfo ) ;															// }XNnȟn

extern	int			MakeMask_UseGParam( int Width, int Height, int ASyncLoadFlag = FALSE ) ;								// }XNf[^̒ǉ
extern	int			LoadMask_UseGParam( const TCHAR *FileName, int ASyncLoadFlag = FALSE ) ;								// }XNf[^[h 
extern	int			LoadDivMask_UseGParam( const TCHAR *FileName, int AllNum, int XNum, int YNum, int XSize, int YSize, int *HandleBuf, int ASyncLoadFlag = FALSE ) ;	// }XN摜番ǂ݂

}

#endif //	DX_NON_MASK

#endif // __DXMASK_H__
