// -------------------------------------------------------------------------------
// 
// 		cwCu		VXevOwb_t@C
// 
// 				Ver 3.11d
// 
// -------------------------------------------------------------------------------

#ifndef __DXSYSTEM_H__
#define __DXSYSTEM_H__

// CN[h ------------------------------------------------------------------
#include "DxCompileConfig.h"
#include "DxLib.h"
#include "DxStatic.h"
#include "DxBaseFunc.h"

#if !defined( __ANDROID )
#include "Windows/DxSystemWin.h"
#endif

#ifdef __ANDROID
#include "Android/DxSystemAndroid.h"
#endif

namespace DxLib
{

// }N` --------------------------------------------------------------------


// \̒` --------------------------------------------------------------------

// VXef[^\
struct DXSYSTEMDATA
{
	int						DxLib_InitializeFlag ;				// cwCȕĂ邩tO
	int						DxLib_RunInitializeFlag ;			// cwCȕAtO

	int						NotWinFlag ;						// cwCũEChE֘A@\gpȂtO
	int						NotDrawFlag ;						// `@\gpȂtO
	int						NotSoundFlag ;						// TEh@\gpȂtO
	int						NotInputFlag ;						// ͏Ԏ擾@\gpȂtO

	int						EndRequestFlag ;					// INGXgtO
	int						ASyncLoadFlag ;						// 񓯊ǂݍ݃tO
} ;

// e[u-----------------------------------------------------------------------

// ϐ錾 --------------------------------------------------------------

extern DXSYSTEMDATA DxSysData ;

// ֐vg^Cv錾-----------------------------------------------------------

// EI֌W
extern	int			DxLib_SysInit( void ) ;													// DxSysData ֌W̏s
extern	int			DxLib_EndRequest( void ) ;												// INGXgs
extern	int			DxLib_GetEndRequest( void ) ;											// INGXg̏Ԃ擾

// G[֐
extern	int			DxLib_Error( const TCHAR *ErrorStr ) ;									// CũG[s				
extern	int			DxLib_FmtError( const TCHAR *FormatString, ... ) ;						// tCũG[s	

// 񓯊ǂݍ݊֌W
extern	int			GetASyncLoadFlag( void ) ;												// 񓯊ǂݍ݂sǂ擾

// ϊ
extern	int			WCharToMBChar( int CodePage, const DXWCHAR *Src, char *Dest, int DestSize ) ;		// Ch}`oCgɕϊ
extern	int			MBCharToWChar( int CodePage, const char *Src, DXWCHAR *Dest, int DestSize ) ;		// }`oCgChɕϊ

}

#endif // __DXSYSTEM_H__

