//-----------------------------------------------------------------------------
// 
// 		cwCu		WindowsOSp`揈vO
// 
//  	Ver 3.11d
// 
//-----------------------------------------------------------------------------

// cwCu쐬p`
#define __DX_MAKE

// CN[h ---------------------------------------------------------------
#include "DxGraphicsWin.h"
#include "DxWindow.h"
#include "DxWinAPI.h"
#include "../DxSystem.h"
#include "../DxLog.h"
#include "../DxModel.h"
#include "../DxBaseFunc.h"
#include "../DxGraphics.h"

namespace DxLib
{

// }N` -----------------------------------------------------------------

// \̐錾 -----------------------------------------------------------------

// f[^` -----------------------------------------------------------------

static int UseGDIFlag ;							// GDI gp邩ǂ

// ֐錾 -------------------------------------------------------------------

static int EnumDirect3DAdapter() ;												// Direct3D ̃A_v^񋓂
static int UseChangeDisplaySettings( void ) ;									// ChangeDisplaySettings gpĉʃ[hύX

// vO -----------------------------------------------------------------

// ݂̉ʂ̃tbV[g擾
extern int NS_GetRefreshRate( void )
{
	int RefreshRate = -1 ;

	// tbV[g̎擾
	if( WinData.WindowsVersion >= DX_WINDOWSVERSION_NT31 )
	{
		HDC hdc ;
		
		hdc = GetDC( NS_GetMainWindowHandle() ) ;
		if( hdc )
		{
			RefreshRate = GetDeviceCaps( hdc, VREFRESH ) ;
			ReleaseDC( NS_GetMainWindowHandle(), hdc ) ;

			if( RefreshRate < 50 ) RefreshRate = -1 ;
		}
	}

	return RefreshRate ;
}

// ChangeDisplaySettings gpĉʃ[hύX
static int UseChangeDisplaySettings( void )
{
//	HRESULT hr ;
	int DesktopWidth, DesktopHeight, DesktopColorBitDepth ;
	DEVMODE DevMode;

	// ̉ʂ̑傫𓾂
	NS_GetDefaultState( &DesktopWidth, &DesktopHeight, &DesktopColorBitDepth ) ;

	DXST_ERRORLOGFMT_ADD(( _T( "ʃ[h̕ύXJn܂ %u x %u  %u bit " ), GRA2.MainScreenSizeX, GRA2.MainScreenSizeY, GRA2.MainScreenColorBitDepth )) ;
	DXST_ERRORLOG_TABADD ;

	// ΉĂJ[rbg[x 16  32 ̂
	if( GRA2.MainScreenColorBitDepth != 16 &&
		GRA2.MainScreenColorBitDepth != 32 )
		return -1 ;

	// fBXvC[h̕ύX
	DXST_ERRORLOG_ADD( _T( "ʉ𑜓xύX܂... " ) ) ;

	// Win32 API gĉʃ[hύX
	{
		// p[^Zbg
		_MEMSET( &DevMode, 0, sizeof( DevMode ) ) ;
		DevMode.dmSize             = sizeof( DevMode ) ;
		DevMode.dmPelsWidth        = GRA2.MainScreenSizeX ;
		DevMode.dmPelsHeight       = GRA2.MainScreenSizeY ;
		DevMode.dmBitsPerPel       = GRA2.MainScreenColorBitDepth ;
		DevMode.dmFields           = DM_BITSPERPEL | DM_PELSWIDTH | DM_PELSHEIGHT ;
		if( GRA2.MainScreenRefreshRate != 0 )
		{
			DevMode.dmDisplayFrequency  = GRA2.MainScreenRefreshRate ;
			DevMode.dmFields           |= DM_DISPLAYFREQUENCY ;
		}

		// ʃ[h`FW
		if( ChangeDisplaySettings( &DevMode, CDS_FULLSCREEN ) != DISP_CHANGE_SUCCESSFUL )
		{
			// s烊tbV[gw薳łx
			GRA2.MainScreenRefreshRate = 0 ;
			DevMode.dmDisplayFrequency = 0 ;
			DevMode.dmFields           &= ~DM_DISPLAYFREQUENCY ;
			if( ChangeDisplaySettings( &DevMode, 0/*CDS_FULLSCREEN*/ ) != DISP_CHANGE_SUCCESSFUL )
			{
				// łʖڂŁAʃ[h 320x240 ꍇ
				// [ 320x240 [hŎ
				if( GRA2.MainScreenSizeX == 320 && GRA2.MainScreenSizeY == 240 )
				{
					SetMainScreenSize( 640, 480 ) ;
					NS_SetEmulation320x240( TRUE ) ;
					DevMode.dmPelsWidth        = GRA2.MainScreenSizeX ;
					DevMode.dmPelsHeight       = GRA2.MainScreenSizeY ;
					if( ChangeDisplaySettings( &DevMode, 0/*CDS_FULLSCREEN*/ ) != DISP_CHANGE_SUCCESSFUL )
					{
						goto ERRORLABEL ;
					}
					SetWindowStyle() ;
				}
				else
				{
ERRORLABEL:
					DXST_ERRORLOG_ADD( _T( "ʃ[h̕ύXɎs܂\n" ) ) ;
					DXST_ERRORLOG_TABSUB ;
					return -1 ;
				}
			}
		}
	}

	GRA2.UseChangeDisplaySettings = TRUE ;
	DXST_ERRORLOG_ADD( _T( "܂\n" ) ) ;

	return 0 ;
}

// DirectX ֘Ȁ( 0:  -1:s )
extern int InitializeDirectX()
{
	int result ;

	// Direct3D9.DLL ̓ǂݍ
	if( Graphics_LoadDLL() < 0 )
		return -1 ;

	// DirectDraw7 ̎擾݂
	if( OldGraphicsInterface_Create() < 0 )
	{
		Graphics_FreeDLL() ;
		return -1 ;
	}

	// n[hEGAgpȂAtOĂȂꍇ Direct3D9 ̎擾݂
	GRA2.ValidHardWare = FALSE ;
	if( GRA2.NotUseHardWare == FALSE )
	{
		// tXN[[hŊ Vista ȍ~̏ꍇŕ\ʂƗʂ̑傫Ⴄꍇ͂ŉʃ[hύX
		result = 0 ;
		if( NS_GetWindowModeFlag() == FALSE && WinData.WindowsVersion >= DX_WINDOWSVERSION_VISTA &&
			( GRA2.ValidGraphDisplayArea || GBASE.Emulation320x240Flag || GRH.FullScreenEmulation320x240 ) )
		{
			result = UseChangeDisplaySettings() ;
		}

		// ʃ[hύXĂȂAʃ[h̕ύXꍇ̂ Direct3DDevice9 쐬
		if( result == 0 )
		{
CREATEDIRECT3D9OBJECT :
			if( Graphics_Create() == 0 )
			{
				int Ret ;

				// Direct3DDevice9 ̎擾݂
				Ret = CreateDirect3D9DeviceObject() ;
				if( Ret == -2 )
				{
					goto CREATEDIRECT3D9OBJECT ;
				}
				else
				if( Ret == 0 )
				{
					// Zobt@ ̍쐬݂
					if( CreateDirect3D9ZBufferObject() == 0 )
					{
						GRA2.ValidHardWare = TRUE ;

						// VF[_[̍쐬
						SetupDirect3D9Shader() ;

						// VF[_[gpłꍇƂłȂꍇŏ𕪊
						if( GRH.UseShader )
						{
							// _錾̍쐬
							CreateDirect3D9VertexDeclaration() ;

#ifndef DX_NON_MODEL
							// {[eNX`̍쐬
							CreateRGBtoVMaxRGBVolumeTexture() ;
#endif // DX_NON_MODEL
						}
					}
				}
			}
		}
		if( GRA2.ValidHardWare == FALSE )
		{
			// ǂꂩłsꍇ Direct3D ̃IuWFNg

			// Zobt@ ̉
			if( GRH.ZBufferSurface )
			{
				Graphics_ObjectRelease( GRH.ZBufferSurface ) ;
				GRH.ZBufferSurface = NULL ;
			}

			// Direct3DDevice9 ̉
			GraphicsDevice_Release() ;
			GRH.BeginSceneFlag = FALSE ;

			// Direct3D9 ̉
			Graphics_Release() ;
		}

#if 0
		// fBXvC[h̗񋓂s
		{
			int i, Num16, Num32 ;
			D_D3DDISPLAYMODE Mode ;
			DISPLAYMODEDATA *Disp ;

			Num32 = Graphics_GetAdapterModeCount( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DFMT_X8R8G8B8 ) ;
			Num16 = Graphics_GetAdapterModeCount( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DFMT_R5G6B5 ) ;

			if( GRH.DisplayMode )
			{
				DXFREE( GRH.DisplayMode ) ;
				GRH.DisplayMode = NULL ;
			}
			GRH.DisplayModeNum = Num32 + Num16 ;
			GRH.DisplayMode = ( DISPLAYMODEDATA * )DXALLOC( sizeof( DISPLAYMODEDATA ) * ( Num32 + Num16 ) ) ;
			if( GRH.DisplayMode == NULL )
			{
				return DXST_ERRORLOG_ADD( _T( "fBXvC[hۑ郁̈̊mۂɎs܂\n" ) ) ;
			}

			Disp = GRH.DisplayMode ;
			for( i = 0 ; i < Num32 ; i ++, Disp ++ )
			{
				Graphics_EnumAdapterModes( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DFMT_X8R8G8B8, i, &Mode ) ;
				Disp->Width = Mode.Width ;
				Disp->Height = Mode.Height ;
				Disp->ColorBitDepth = 32 ;
				Disp->RefreshRate = Mode.RefreshRate ;
			}
			for( i = 0 ; i < Num16 ; i ++, Disp ++ )
			{
				Graphics_EnumAdapterModes( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DFMT_R5G6B5, i, &Mode ) ;
				Disp->Width = Mode.Width ;
				Disp->Height = Mode.Height ;
				Disp->ColorBitDepth = 16 ;
				Disp->RefreshRate = Mode.RefreshRate ;
			}
		}
#endif
	}

	// n[hEGAANZ[VgpȂꍇ͂ŉʃ[hύX
	if( GRA2.ValidHardWare == FALSE )
	{
		// tXN[̏ꍇ̂ݏ
		if( NS_GetWindowModeFlag() == FALSE )
		{
			if( UseChangeDisplaySettings() < 0 )
				return -1 ;
		}

		// urxmb҂̎Ԃ擾
		GraphicsDevice_WaitVSyncInitialize() ;

		// I
		return 0 ;
	}

	// I
	return 0 ;
}

// DirectX ֘Ǎn
extern int TerminateDirectX()
{
#ifndef DX_NON_MODEL
	// f̒_obt@
	MV1TerminateVertexBufferAll() ;
#endif

	// _錾̉
	TerminateDirect3D9VertexDeclaration() ;

	// VF[_[̉
	TerminateDirect3D9Shader() ;

//	// n[hEGAANZ[^gpȂꍇ͂ŉʃ[hɖ߂
//	if( /*NS_GetWindowModeFlag() == FALSE &&*/
//		( GRA2.ValidHardWare == FALSE ||
//		 ( WinData.WindowsVersion >= DX_WINDOWSVERSION_VISTA && ( GRA2.ValidGraphDisplayArea || GBASE.Emulation320x240Flag || GRH.FullScreenEmulation320x240 ) ) ) )
	// ChangeDisplaySettings gpĉʃ[hύXꍇ͂ŉʃ[hɖ߂
	if( GRA2.UseChangeDisplaySettings )
	{
		GRA2.UseChangeDisplaySettings = FALSE ;
		ChangeDisplaySettings( NULL, 0 ) ;
	}

	// Zobt@ ̉
	if( GRH.ZBufferSurface )
	{
		Graphics_ObjectRelease( GRH.ZBufferSurface ) ;
		GRH.ZBufferSurface = NULL ;
	}

	// TuobNobt@̉
	if( GRH.SubBackBufferSurface )
	{
		Graphics_ObjectRelease( GRH.SubBackBufferSurface ) ;
		GRH.SubBackBufferSurface = NULL ;
	}

	// obNobt@̉
	if( GRH.BackBufferSurface )
	{
		Graphics_ObjectRelease( GRH.BackBufferSurface ) ;
		GRH.BackBufferSurface = NULL ;
	}

#ifndef DX_NON_MODEL
	// {[eNX`̉
	if( GRH.RGBtoVMaxRGBVolumeTexture )
	{
		Graphics_ObjectRelease( GRH.RGBtoVMaxRGBVolumeTexture ) ;
		GRH.RGBtoVMaxRGBVolumeTexture = NULL ;
	}
#endif // DX_NON_MODEL

	// Direct3DDevice9 ̉
	GraphicsDevice_Release() ;
	GRH.BeginSceneFlag = FALSE ;

	// Direct3D9 ̉
	Graphics_Release() ;

	// DirectDraw ̉
	OldGraphicsInterface_Release() ;

	// d3d9.dll ̉
	Graphics_FreeDLL() ;

	// fBXvC[hpɊmۂ̉
	if( GRH.DisplayMode )
	{
		HeapFree( GetProcessHeap(), 0, GRH.DisplayMode ) ;
		GRH.DisplayMode = NULL ;
	}

	// I
	return 0 ;
}


















































// @ˑ֐̃R[h

// Direct3D ̃A_v^񋓂
static int EnumDirect3DAdapter()
{
	int i ;

	if( GRH.ValidAdapterInfo ) return 0 ;

	// 
	if( DxSysData.DxLib_InitializeFlag == FALSE || DxLib_GetEndRequest() )
	{
		// Direct3D9.DLL ̓ǂݍ
		if( Graphics_LoadDLL() < 0 )
			return -1 ;

		// Direct3D9 ̍쐬
		if( Graphics_Create() == 0 )
		{
			GRH.AdapterInfoNum = Graphics_GetAdapterCount() ;
			for( i = 0 ; i < GRH.AdapterInfoNum ; i ++ )
				Graphics_GetAdapterIdentifier( i, 0, &GRH.AdapterInfo[ i ] ) ;

			// Direct3D9 ̉
			Graphics_Release() ;
		}

		// d3d9.dll ̉
		Graphics_FreeDLL() ;
	}
	else
	{
		GRH.AdapterInfoNum = Graphics_GetAdapterCount() ;
		for( i = 0 ; i < GRH.AdapterInfoNum ; i ++ )
			Graphics_GetAdapterIdentifier( i, 0, &GRH.AdapterInfo[ i ] ) ;
	}

	GRH.ValidAdapterInfo = TRUE ;

	// I
	return 0 ;
}

// ccgpftchݒ肷
extern	int		NS_SetDDrawUseGuid( const GUID FAR *Guid )
{
	int i ;

	if( EnumDirect3DAdapter() != 0 ) return -1 ;

	// ŵfthc邩ǂׂ
	for( i = 0 ; i < GRH.AdapterInfoNum && _MEMCMP( Guid, &GRH.AdapterInfo[ i ].DeviceIdentifier, sizeof( GUID ) ) != 0 ; i ++ ){}
	if( i == GRH.AdapterInfoNum ) return -1 ;

	// lۑ
	GRH.ValidAdapterNumber = TRUE ;
	GRH.UseAdapterNumber = i ;

	// I
	return 0 ;
}

/*߂l IDirectDraw7 * ɃLXgĉ*/			// ݎgpĂccIuWFNg̃AhX擾
extern	const void					*NS_GetUseDDrawObj( void )
{
	// I
	return OldGraphicsInterface_GetObject() ;
}

// L DirectDraw foCX GUID 擾
extern	const GUID *				NS_GetDirectDrawDeviceGUID( int Number )
{
	if( EnumDirect3DAdapter() != 0 || Number >= GRH.AdapterInfoNum ) return NULL ;

	return &GRH.AdapterInfo[ Number ].DeviceIdentifier ;
}

// L DirectDraw foCX̖O𓾂
extern	int						NS_GetDirectDrawDeviceDescription( int Number, char *StringBuffer )
{
	if( EnumDirect3DAdapter() != 0 || Number >= GRH.AdapterInfoNum ) return -1 ;

	_STRCPY( StringBuffer, GRH.AdapterInfo[ Number ].Description ) ;

	// I
	return 0 ;
}

// L DirectDraw foCX̐擾
extern	int						NS_GetDirectDrawDeviceNum( void )
{
	if( EnumDirect3DAdapter() != 0 ) return -1 ;

	return GRH.AdapterInfoNum ;
}


// ccgp邩ǂZbg
extern	int		NS_SetUseDirectDrawFlag( int Flag )
{
	// Ôݎgp\
	if( DxSysData.DxLib_InitializeFlag == TRUE ) return -1 ;

	GRA2.NotUseHardWare = !Flag ;

	// I
	return 0 ;
}

// fch`KvƂ邩AύX
extern	int		NS_SetUseGDIFlag( int Flag )
{
	// tOۑ
	UseGDIFlag = Flag ;

	// n[hEGAgpĂ邩ǂŏ𕪊
	if( GRA2.ValidHardWare )
	{
		// n[hEGA_O[h̏ꍇ
		if( GraphicsDevice_IsValid() == 0 ) return 0 ;

		// foCX̐ݒ
		if( Flag == FALSE )
		{
			GraphicsDevice_SetDialogBoxMode( FALSE ) ;
		}
		else
		{
			GraphicsDevice_SetDialogBoxMode( FALSE ) ;
			GraphicsDevice_SetDialogBoxMode( TRUE ) ;
		}
	}
	else
	{
		// \tgEGA_O[hł͓ɂ邱Ɩ
	}

	// I
	return 0 ;
}

// fch`KvƂ邩̏Ԃ擾
extern int NS_GetUseGDIFlag( void )
{
	return UseGDIFlag ;
}

// fBXvC[hf[^̏ZbgAbv
extern void SetupDisplayModeData( int *Num, DISPLAYMODEDATA **Buffer )
{
	int i, ModeNum ;
	DEVMODE DevMode ;
	DISPLAYMODEDATA *Disp ;

	// ɃmۂĂ
	if( *Buffer )
	{
		HeapFree( GetProcessHeap(), 0, *Buffer ) ;
		*Buffer = NULL ;
	}

	// 𐔂
	*Num = 0 ;
	ModeNum = 0 ;
	for( ModeNum ;  ; ModeNum ++ )
	{
		_MEMSET( &DevMode, 0, sizeof( DevMode ) ) ;
		if( EnumDisplaySettings( NULL, ModeNum, &DevMode ) == 0 ) break ;

		// 16bit ȉ̃[h͏O
		if( DevMode.dmBitsPerPel >= 16 )
		{
			( *Num ) ++ ;
		}
	}

	// i[郁̈̊m
	*Buffer = ( DISPLAYMODEDATA * )HeapAlloc( GetProcessHeap(), 0, sizeof( DISPLAYMODEDATA ) * *Num ) ;
	if( *Buffer == NULL )
	{
		*Num = 0 ;
		return ;
	}

	// 擾
	Disp = *Buffer ;
	for( i = 0 ; i < ModeNum ; i ++ )
	{
		_MEMSET( &DevMode, 0, sizeof( DevMode ) ) ;
		EnumDisplaySettings( NULL, i, &DevMode ) ;
		if( DevMode.dmBitsPerPel >= 16 )
		{
			Disp->Width         = DevMode.dmPelsWidth ;
			Disp->Height        = DevMode.dmPelsHeight ;
			Disp->ColorBitDepth = DevMode.dmBitsPerPel ;
			Disp->RefreshRate   = DevMode.dmDisplayFrequency ;
			Disp ++ ;
		}
	}
}

}

