// -------------------------------------------------------------------------------
// 
// 		cwCu		A[JCuvO
// 
// 				Ver 3.11d
// 
// -------------------------------------------------------------------------------


// cwCu쐬p`
#define __DX_MAKE

// CN[h-------------------------------------------------------------------
#include "DxArchive_.h"
#include "DxBaseFunc.h"
#include "DxMemory.h"
#include "DxFile.h"
#include "DxFont.h"
#include "DxLog.h"
#include "DxSystem.h"
#include <stdio.h>

#ifdef __WINDOWS__
#include "Windows/DxWindow.h"
#endif // __WINDOWS__

namespace DxLib
{

#ifndef DX_NON_DXA

// }N` --------------------------------------------------------------------

#define DXARCD						DX_ArchiveDirData
//#define CHECKMULTIBYTECHAR(CP)		(( (unsigned char)*(CP) >= 0x81 && (unsigned char)*(CP) <= 0x9F ) || ( (unsigned char)*(CP) >= 0xE0 && (unsigned char)*(CP) <= 0xFC ))	// TRUE:QoCg  FALSE:PoCg
#define CHARUP(C)					((C) >= _T( 'a' ) && (C) <= _T( 'z' ) ? (C) - _T( 'a' ) + _T( 'A' ) : (C))

#define DXARC_ID_AND_VERSION_SIZE	(sizeof( WORD ) * 2)

#define DXARC_HEAD_VER3_SIZE		(24)
#define DXARC_HEAD_VER4_SIZE		(28)
#define DXARC_HEAD_VER6_SIZE		(48)

#define DXARC_FILEHEAD_VER1_SIZE	(40)			// Ver0x0001  DXARC_FILEHEAD \̂̃TCY
#define DXARC_FILEHEAD_VER2_SIZE	(44)			// Ver0x0002  DXARC_FILEHEAD \̂̃TCY
#define DXARC_FILEHEAD_VER6_SIZE	(64)			// Ver0x0006  DXARC_FILEHEAD \̂̃TCY

#if defined( DX_GCC_COMPILE ) || defined( __ANDROID )
#define NONE_PAL		(0xffffffffffffffffULL)
#else
#define NONE_PAL		(0xffffffffffffffff)
#endif

// \̒` --------------------------------------------------------------------

// DXA_DIR_FindFirst ̏Ŏgp\
struct DXA_DIR_FINDDATA
{
	int							UseArchiveFlag;					// A[JCut@CgpĂ邩tO
	int							UseArchiveIndex;				// A[JCugpĂꍇAgpĂA[JCut@Cf[^̃CfbNX
	DWORD_PTR					FindHandle;						// t@Cpnh
} ;

// DXA_FindFirst ̏Ŏgp\
struct DXA_FINDDATA
{
	DXARC						*Container;						// Ώۂ̂cw`t@C
	char						SearchStr[MAX_PATH];			// 
	union
	{
		DXARC_DIRECTORY			*Directory;						// Ώۂ̃fBNg
		DXARC_DIRECTORY_VER5	*DirectoryV5;					// Ώۂ̃fBNg(Ver5ȑOp)
	};
	DWORD						ObjectCount;					// ɓnfBNgIuWFNg̃CfbNX
} ;

// ϐ錾 --------------------------------------------------------------

// A[JCufBNgɌẴׂf[^
DXARC_DIR DX_ArchiveDirData ;

// ֐vg^Cv錾-----------------------------------------------------------

static DXARC_FILEHEAD_VER5 *DXA_GetFileInfoV5( DXARC *DXA, const char *FilePath ) ;				// t@C̏𓾂
static DXARC_FILEHEAD      *DXA_GetFileInfo( DXARC *DXA, const char *FilePath ) ;				// t@C̏𓾂
static int DXA_ConvSearchData( DXARC *DXA, DXARC_SEARCHDATA *Dest, const char *Src, int *Length ) ;		// p̃f[^ɕϊ( k \ I )
static int DXA_ChangeCurrentDirectoryFast(   DXARC *DXA, DXARC_SEARCHDATA *SearchData ) ;			// A[JCũfBNgpXύX( 0:  -1:s )
static int DXA_ChangeCurrentDirectoryBase(   DXARC *DXA, const char *DirectoryPath, bool ErrorIsDirectoryReset, DXARC_SEARCHDATA *LastSearchData = NULL ) ;		// A[JCũfBNgpXύX( 0:  -1:s )
//static int DXA_Decode( void *Src, void *Dest ) ;											// f[^𓀂( ߂l:𓀌̃f[^TCY )
static void DXA_KeyCreate( const char *Source, unsigned char *Key ) ;						// 쐬
static void DXA_KeyConv( void *Data, LONGLONG SizeLL, LONGLONG PositionLL, unsigned char *Key ) ;			// gp Xor Z( Key ͕K DXA_KEYSTR_LENGTH ̒Ȃ΂ȂȂ )
static void DXA_KeyConvFileRead( void *Data, ULONGLONG Size, DWORD_PTR FilePointer, unsigned char *Key, LONGLONG Position = -1 ) ;	// t@Cǂݍ񂾃f[^gp Xor Z֐( Key ͕K DXA_KEYSTR_LENGTH ̒Ȃ΂ȂȂ )
static int DXA_FindProcess( DXA_FINDDATA *FindData, FILEINFO *FileInfo );					// ɓKIuWFNg(Ώۂ ObjectCount CfbNXƂƂ납)(߂l -1:G[ 0:)

static int DXA_DIR_OpenArchive( const TCHAR *FilePath, int ArchiveIndex = -1, int OnMemory = FALSE, int ASyncThread = FALSE ) ;	// A[JCut@CJ
static int DXA_DIR_GetArchive( const TCHAR *FilePath ) ;									// ɊJĂA[JCũnh擾( ߂l: -1= 0ȏ:nh )
static int DXA_DIR_CloseArchive( int ArchiveHandle ) ;										// A[JCut@C
static void DXA_DIR_CloseWaitArchive( void ) ;												// gp̂҂ĂA[JCut@CSĕ
static int DXA_DIR_ConvertFullPath( const TCHAR *Src, TCHAR *Dest ) ;							// SẲp啶ɂȂAtpXɕϊ
static int DXA_DIR_AnalysisFileNameAndDirPath( DXARC *DXA, const char *Src, char *FileName = 0, char *DirPath = 0 ) ;	// t@CꏏɂȂĂƕĂpXt@CƃfBNgpX𕪊BtpXłKv͖At@CłǂADirPath ̏I[  }[N͕tȂ
static int DXA_DIR_FileNameCmp( DXARC *DXA, const char *Src, const char *CmpStr );						// CmpStr ̏ Src K邩ǂ𒲂ׂ( 0:K  -1:KȂ )
static int DXA_DIR_OpenTest( const TCHAR *FilePath, int *ArchiveIndex, char *ArchivePath, char *ArchiveFilePath );	// A[JCut@CtH_ɌĂăt@CJ̏𓾂( -1:A[JCuƂĂ݂͑Ȃ  0:݂ )

static int DXA_DirectoryKeyConv( DXARC *DXA, DXARC_DIRECTORY *Dir ) ;						// w̃fBNgf[^̈Í( ۂƃɓǂݍ񂾏ꍇp )
static int DXA_DirectoryKeyConvV5( DXARC *DXA, DXARC_DIRECTORY_VER5 *Dir ) ;				// w̃fBNgf[^̈Í( ۂƃɓǂݍ񂾏ꍇp )

// vO --------------------------------------------------------------------

// t@C̏𓾂
static DXARC_FILEHEAD_VER5 *DXA_GetFileInfoV5( DXARC *DXA, const char *FilePath )
{
	DXARC_DIRECTORY_VER5 *OldDir ;
	DXARC_FILEHEAD_VER5 *FileH ;
	DWORD FileHeadSize ;
	BYTE *NameData ;
	int i, j, k, Num ;
	DXARC_SEARCHDATA SearchData ;

	// ̃fBNgۑĂ
	OldDir = DXA->CurrentDirectoryV5 ;

	// t@CpX \ or / ܂܂ĂꍇAfBNgύXs
	if( _STRCHR( FilePath, '\\' ) != NULL || _STRCHR( FilePath, '/' ) != NULL )
	{
		// JgfBNgړĨt@CfBNgɕύX
		if( DXA_ChangeCurrentDirectoryBase( DXA, FilePath, false, &SearchData ) >= 0 )
		{
			// G[NȂꍇ̓t@CfBNgƂɂȂ̂ŃG[
			goto ERR ;
		}
	}
	else
	{
		// t@Cpf[^ɕϊ
		DXA_ConvSearchData( DXA, &SearchData, FilePath, NULL ) ;
	}

	// ̃t@CT
	FileHeadSize = DXA->HeadV5.Version >= 0x0002 ? DXARC_FILEHEAD_VER2_SIZE : DXARC_FILEHEAD_VER1_SIZE ;
	FileH        = ( DXARC_FILEHEAD_VER5 * )( DXA->Table.FileTable + DXA->CurrentDirectoryV5->FileHeadAddress ) ;
	Num          = ( int )DXA->CurrentDirectoryV5->FileHeadNum ;
	for( i = 0 ; i < Num ; i ++, FileH = (DXARC_FILEHEAD_VER5 *)( (BYTE *)FileH + FileHeadSize ) )
	{
		// fBNg`FbN
		if( ( FileH->Attributes & FILE_ATTRIBUTE_DIRECTORY ) != 0 ) continue ;

		// 񐔂ƃpeB`FbN
		NameData = DXA->Table.NameTable + FileH->NameAddress ;
		if( SearchData.PackNum != ((WORD *)NameData)[0] || SearchData.Parity != ((WORD *)NameData)[1] ) continue ;

		// `FbN
		NameData += 4 ;
		for( j = 0, k = 0 ; j < SearchData.PackNum ; j ++, k += 4 )
			if( *((DWORD *)&SearchData.FileName[k]) != *((DWORD *)&NameData[k]) ) break ;

		// Kt@C炱ŏI
		if( SearchData.PackNum == j ) break ;
	}

	// G[
	if( i == Num ) goto ERR ;
	
	// fBNgɖ߂
	DXA->CurrentDirectoryV5 = OldDir ;
	
	// ړĨt@C̃AhXԂ
	return FileH ;
	
ERR :
	// fBNgɖ߂
	DXA->CurrentDirectoryV5 = OldDir ;
	
	// G[I
	return NULL ;
}

// t@C̏𓾂
static DXARC_FILEHEAD *DXA_GetFileInfo( DXARC *DXA, const char *FilePath )
{
	DXARC_DIRECTORY *OldDir ;
	DXARC_FILEHEAD *FileH ;
	DWORD FileHeadSize ;
	BYTE *NameData ;
	int i, j, k, Num ;
	DXARC_SEARCHDATA SearchData ;

	// ̃fBNgۑĂ
	OldDir = DXA->CurrentDirectory ;

	// t@CpX \ or / ܂܂ĂꍇAfBNgύXs
	if( _STRCHR( FilePath, '\\' ) != NULL || _STRCHR( FilePath, '/' ) != NULL )
	{
		// JgfBNgړĨt@CfBNgɕύX
		if( DXA_ChangeCurrentDirectoryBase( DXA, FilePath, false, &SearchData ) >= 0 )
		{
			// G[NȂꍇ̓t@CfBNgƂɂȂ̂ŃG[
			goto ERR ;
		}
	}
	else
	{
		// t@Cpf[^ɕϊ
		DXA_ConvSearchData( DXA, &SearchData, FilePath, NULL ) ;
	}

	// ̃t@CT
	FileHeadSize = DXARC_FILEHEAD_VER6_SIZE ;
	FileH        = ( DXARC_FILEHEAD * )( DXA->Table.FileTable + DXA->CurrentDirectory->FileHeadAddress ) ;
	Num          = ( int )DXA->CurrentDirectory->FileHeadNum ;
	for( i = 0 ; i < Num ; i ++, FileH = (DXARC_FILEHEAD *)( (BYTE *)FileH + FileHeadSize ) )
	{
		// fBNg`FbN
		if( ( FileH->Attributes & FILE_ATTRIBUTE_DIRECTORY ) != 0 ) continue ;

		// 񐔂ƃpeB`FbN
		NameData = DXA->Table.NameTable + FileH->NameAddress ;
		if( SearchData.PackNum != ((WORD *)NameData)[0] || SearchData.Parity != ((WORD *)NameData)[1] ) continue ;

		// `FbN
		NameData += 4 ;
		for( j = 0, k = 0 ; j < SearchData.PackNum ; j ++, k += 4 )
			if( *((DWORD *)&SearchData.FileName[k]) != *((DWORD *)&NameData[k]) ) break ;

		// Kt@C炱ŏI
		if( SearchData.PackNum == j ) break ;
	}

	// G[
	if( i == Num ) goto ERR ;
	
	// fBNgɖ߂
	DXA->CurrentDirectory = OldDir ;
	
	// ړĨt@C̃AhXԂ
	return FileH ;
	
ERR :
	// fBNgɖ߂
	DXA->CurrentDirectory = OldDir ;
	
	// G[I
	return NULL ;
}


// p̃f[^ɕϊ( k \ I )
static int DXA_ConvSearchData( DXARC *DXA, DXARC_SEARCHDATA *Dest, const char *Src, int *Length )
{
	int i, StringLength ;
	WORD ParityData ;

	ParityData = 0 ;
	for( i = 0 ; Src[i] != '\0' && Src[i] != '\\' && Src[i] != '/' ; )
	{
		if( CheckMultiByteChar( Src[i], DXA->CharSet ) == TRUE )
		{
			// QoCg̏ꍇ͂̂܂܃Rs[
			*((WORD *)&Dest->FileName[i]) = *((WORD *)&Src[i]) ;
			ParityData += (BYTE)Src[i] + (BYTE)Src[i+1] ;
			i += 2 ;
		}
		else
		{
			// ̏ꍇ͑啶ɕϊ
			if( Src[i] >= 'a' && Src[i] <= 'z' )	Dest->FileName[i] = (BYTE)Src[i] - 'a' + 'A' ;
			else									Dest->FileName[i] = Src[i] ;
			ParityData += ( WORD )Dest->FileName[i] ;
			i ++ ;
		}
	}

	// ̒ۑ
	if( Length != NULL ) *Length = i ;

	// S̔{̈ʒu܂łO
	StringLength = ( ( i + 1 ) + 3 ) / 4 * 4 ;
	_MEMSET( &Dest->FileName[i], 0, StringLength - i ) ;

	// peBf[^̕ۑ
	Dest->Parity = ParityData ;

	// pbNf[^̕ۑ
	Dest->PackNum = ( WORD )( StringLength / 4 ) ;

	// I
	return 0 ;
}






// 쐬
void DXA_KeyCreate( const char *Source, unsigned char *Key )
{
	size_t Len ;

	if( Source == NULL )
	{
		_MEMSET( Key, 0xaa, DXA_KEYSTR_LENGTH ) ;
	}
	else
	{
		Len = strlen( Source ) ;
		if( Len > DXA_KEYSTR_LENGTH )
		{
			_MEMCPY( Key, Source, DXA_KEYSTR_LENGTH ) ;
		}
		else
		{
			//  DXA_KEYSTR_LENGTH Z烋[v
			size_t i ;

			for( i = 0 ; i + Len <= DXA_KEYSTR_LENGTH ; i += Len )
				_MEMCPY( Key + i, Source, Len ) ;
			if( i < DXA_KEYSTR_LENGTH )
				_MEMCPY( Key + i, Source, DXA_KEYSTR_LENGTH - i ) ;
		}
	}

	Key[0] = ( unsigned char )( ~Key[0] ) ;
	Key[1] = ( unsigned char )( ( Key[1] >> 4 ) | ( Key[1] << 4 ) ) ;
	Key[2] = ( unsigned char )( Key[2] ^ 0x8a ) ;
	Key[3] = ( unsigned char )( ~( ( Key[3] >> 4 ) | ( Key[3] << 4 ) ) ) ;
	Key[4] = ( unsigned char )( ~Key[4] ) ;
	Key[5] = ( unsigned char )( Key[5] ^ 0xac ) ;
	Key[6] = ( unsigned char )( ~Key[6] ) ;
	Key[7] = ( unsigned char )( ~( ( Key[7] >> 3 ) | ( Key[7] << 5 ) ) ) ;
	Key[8] = ( unsigned char )( ( Key[8] >> 5 ) | ( Key[8] << 3 ) ) ;
	Key[9] = ( unsigned char )( Key[9] ^ 0x7f ) ;
	Key[10] = ( unsigned char )( ( ( Key[10] >> 4 ) | ( Key[10] << 4 ) ) ^ 0xd6 ) ;
	Key[11] = ( unsigned char )( Key[11] ^ 0xcc ) ;
}

// gp Xor Z( Key ͕K DXA_KEYSTR_LENGTH ̒Ȃ΂ȂȂ )
void DXA_KeyConv( void *Data, LONGLONG SizeLL, LONGLONG PositionLL, unsigned char *Key )
{
	int Position ;

	Position = ( int )( PositionLL % DXA_KEYSTR_LENGTH ) ;

	if( SizeLL <= 0xffffffff )
	{
		DWORD SizeT ;
		SizeT = ( DWORD )SizeLL ;

#ifndef DX_NON_INLINE_ASM
		DWORD DataT ;
		DataT = (DWORD)Data ;

		__asm
		{
			MOV EDI, DataT
			MOV ESI, Key

			MOV EAX, SizeT
			CMP EAX, DXA_KEYSTR_LENGTH
			JB LABEL2


			MOV EAX, Position
			CMP EAX, 0
			JE LABEL1


			MOV EDX, SizeT
	LOOP1:
			MOV BL, [ESI+EAX]
			XOR [EDI], BL
			INC EAX
			INC EDI
			DEC EDX
			CMP EAX, DXA_KEYSTR_LENGTH
			JB LOOP1
			XOR ECX, ECX
			MOV Position, ECX

			MOV SizeT, EDX
			CMP EDX, DXA_KEYSTR_LENGTH
			JB LABEL2


	LABEL1:
			MOV EAX, SizeT
			XOR EDX, EDX
			MOV ECX, DXA_KEYSTR_LENGTH
			DIV ECX
			MOV SizeT, EDX
			MOV ECX, EAX

			MOV EAX, [ESI]
			MOV EBX, [ESI+4]
			MOV EDX, [ESI+8]
	LOOP2:
			XOR [EDI],    EAX
			XOR [EDI+4],  EBX
			XOR [EDI+8],  EDX
			ADD EDI, DXA_KEYSTR_LENGTH
			DEC ECX
			JNZ LOOP2


	LABEL2:
			MOV EDX, SizeT
			CMP EDX, 0
			JE LABEL3


			MOV EAX, Position
	LOOP3:
			MOV BL, [ESI+EAX]
			XOR [EDI], BL
			INC EAX
			CMP EAX, DXA_KEYSTR_LENGTH
			JNE LABEL4
			XOR EAX, EAX
	LABEL4:
			INC EDI
			DEC EDX
			JNZ LOOP3
	LABEL3:
		} ;

#else // DX_NON_INLINE_ASM

		BYTE *DataBP ;
		BYTE *KeyBP ;

		DataBP = ( BYTE * )Data ;
		KeyBP = ( BYTE * )Key ;
		if( SizeT >= DXA_KEYSTR_LENGTH )
		{
			if( Position != 0 )
			{
				do
				{
					*DataBP ^= KeyBP[ Position ] ;
					Position ++ ;
					DataBP ++ ;
					SizeT -- ;
				}while( Position < DXA_KEYSTR_LENGTH ) ;
				Position = 0 ;
			}

			if( SizeT >= DXA_KEYSTR_LENGTH )
			{
				DWORD SetNum ;
				DWORD Key1, Key2, Key3 ;

				SetNum = SizeT / DXA_KEYSTR_LENGTH ;
				SizeT -= SetNum * DXA_KEYSTR_LENGTH ;
				Key1 = ( ( DWORD * )KeyBP )[ 0 ] ;
				Key2 = ( ( DWORD * )KeyBP )[ 1 ] ;
				Key3 = ( ( DWORD * )KeyBP )[ 2 ] ;

				do
				{
					( ( DWORD * )DataBP )[ 0 ] ^= Key1 ;
					( ( DWORD * )DataBP )[ 1 ] ^= Key2 ;
					( ( DWORD * )DataBP )[ 2 ] ^= Key3 ;
					DataBP += DXA_KEYSTR_LENGTH ;
					SetNum -- ;
				}while( SetNum > 0 ) ;
			}
		}

		if( SizeT > 0 )
		{
			do
			{
				*DataBP ^= KeyBP[ Position ] ;
				DataBP ++ ;
				Position ++ ;
				if( Position == DXA_KEYSTR_LENGTH )
					Position = 0 ;
				SizeT -- ;
			}while( SizeT > 0 ) ;
		}
#endif // DX_NON_INLINE_ASM
	}
	else
	{
		BYTE *DataBP ;
		BYTE *KeyBP ;

		DataBP = ( BYTE * )Data ;
		KeyBP = ( BYTE * )Key ;
		if( SizeLL >= DXA_KEYSTR_LENGTH )
		{
			if( Position != 0 )
			{
				do
				{
					*DataBP ^= KeyBP[ Position ] ;
					Position ++ ;
					DataBP ++ ;
					SizeLL -- ;
				}while( Position < DXA_KEYSTR_LENGTH ) ;
				Position = 0 ;
			}

			if( SizeLL >= DXA_KEYSTR_LENGTH )
			{
				DWORD SetNum ;
				DWORD Key1, Key2, Key3 ;

				SetNum = ( DWORD )( SizeLL / DXA_KEYSTR_LENGTH ) ;
				SizeLL -= SetNum * DXA_KEYSTR_LENGTH ;
				Key1 = ( ( DWORD * )KeyBP )[ 0 ] ;
				Key2 = ( ( DWORD * )KeyBP )[ 1 ] ;
				Key3 = ( ( DWORD * )KeyBP )[ 2 ] ;

				do
				{
					( ( DWORD * )DataBP )[ 0 ] ^= Key1 ;
					( ( DWORD * )DataBP )[ 1 ] ^= Key2 ;
					( ( DWORD * )DataBP )[ 2 ] ^= Key3 ;
					DataBP += DXA_KEYSTR_LENGTH ;
					SetNum -- ;
				}while( SetNum > 0 ) ;
			}
		}

		if( SizeLL > 0 )
		{
			do
			{
				*DataBP ^= KeyBP[ Position ] ;
				DataBP ++ ;
				Position ++ ;
				if( Position == DXA_KEYSTR_LENGTH )
					Position = 0 ;
				SizeLL -- ;
			}while( SizeLL > 0 ) ;
		}
	}
}

// t@Cǂݍ񂾃f[^gp Xor Z֐( Key ͕K DXA_KEYSTR_LENGTH ̒Ȃ΂ȂȂ )
void DXA_KeyConvFileRead( void *Data, ULONGLONG  Size, DWORD_PTR FilePointer, unsigned char *Key, LONGLONG Position )
{
	LONGLONG pos ;

	// t@C̈ʒu擾Ă
	if( Position == -1 ) pos = ReadOnlyFileAccessTell( FilePointer ) ;
	else                 pos = Position ;

	// ǂݍ
	ReadOnlyFileAccessRead( Data, ( size_t )Size, 1, FilePointer ) ;
	while( ReadOnlyFileAccessIdleCheck( FilePointer ) == FALSE ) Sleep(1);

	// f[^g Xor Z
	DXA_KeyConv( Data, Size, pos, Key ) ;
}

// ɓKIuWFNg(Ώۂ ObjectCount CfbNXƂƂ납)(߂l -1:G[ 0:)
static int DXA_FindProcess( DXA_FINDDATA *FindData, FILEINFO *FileInfo )
{
	BYTE *nameTable;
	DXARC *DXA;
	char *str, *name;
	DWORD fileHeadSize;
	char TempName[ 1024 ] ;

	DXA = FindData->Container;
	nameTable = DXA->Table.NameTable;
	str = FindData->SearchStr;

	if( DXA->V5Flag )
	{
		int i, num, addnum;

		DXARC_DIRECTORY_VER5 *dir;
		DXARC_FILEHEAD_VER5 *file;

		dir = FindData->DirectoryV5;
		num = dir->FileHeadNum;
		addnum = dir->ParentDirectoryAddress == 0xffffffff ? 1 : 2;
		fileHeadSize = DXA->HeadV5.Version >= 0x0002 ? DXARC_FILEHEAD_VER2_SIZE : DXARC_FILEHEAD_VER1_SIZE ;

		if( FindData->ObjectCount == (DWORD)( num + addnum ) ) return -1;

		file = ( DXARC_FILEHEAD_VER5 * )( DXA->Table.FileTable + dir->FileHeadAddress + fileHeadSize * ( FindData->ObjectCount - addnum ) ) ;
		for( i = FindData->ObjectCount; i < num + addnum; i ++, file = (DXARC_FILEHEAD_VER5 *)( (BYTE *)file + fileHeadSize ) )
		{
			if( i < addnum )
			{
					 if( i == 0 ){ if( DXA_DIR_FileNameCmp( DXA, ".",  str ) == 0 ) break; }
				else if( i == 1 ){ if( DXA_DIR_FileNameCmp( DXA, "..", str ) == 0 ) break; }
			}
			else
			{
				name = (char *)( nameTable + file->NameAddress + 4 );
				if( DXA_DIR_FileNameCmp( DXA, name, str ) == 0 ) break;
			}
		}
		FindData->ObjectCount = i;
		if( i == num + addnum )
			return -1;

		if( FileInfo )
		{
			if( i < addnum )
			{
				switch( i )
				{
				case 0: _STRCPY( TempName, "."  ); break;
				case 1: _STRCPY( TempName, ".." ); break;
				}
				FileInfo->DirFlag = 1;
				FileInfo->Size    = 0;
				_MEMSET( &FileInfo->CreationTime,  0, sizeof( FileInfo->CreationTime  ) );
				_MEMSET( &FileInfo->LastWriteTime, 0, sizeof( FileInfo->LastWriteTime ) );
			}
			else
			{
				name = (char *)( nameTable + file->NameAddress );
				_STRCPY( TempName, name + ((WORD *)name)[0] * 4 + 4 );
				FileInfo->DirFlag = (file->Attributes & FILE_ATTRIBUTE_DIRECTORY) != 0 ? TRUE : FALSE;
				FileInfo->Size = (LONGLONG)file->DataSize;
				_FileTimeToLocalDateData( (FILETIME *)&file->Time.Create,    &FileInfo->CreationTime  );
				_FileTimeToLocalDateData( (FILETIME *)&file->Time.LastWrite, &FileInfo->LastWriteTime );
			}

#ifdef UNICODE
			MBCharToWChar( DXA->HeadV5.CodePage, TempName, ( DXWCHAR * )FileInfo->Name, 260 ) ;
#else
			lstrcpy( FileInfo->Name, TempName );
#endif
		}
	}
	else
	{
		ULONGLONG i, num, addnum;
		DXARC_DIRECTORY *dir;
		DXARC_FILEHEAD *file;

		dir = FindData->Directory;
		num = dir->FileHeadNum;
		addnum = dir->ParentDirectoryAddress == NONE_PAL ? 1 : 2;
		fileHeadSize = DXARC_FILEHEAD_VER6_SIZE ;

		if( FindData->ObjectCount == (DWORD)( num + addnum ) ) return -1;

		file = ( DXARC_FILEHEAD * )( DXA->Table.FileTable + dir->FileHeadAddress + fileHeadSize * ( FindData->ObjectCount - addnum ) ) ;
		for( i = FindData->ObjectCount; i < num + addnum; i ++, file = (DXARC_FILEHEAD *)( (BYTE *)file + fileHeadSize ) )
		{
			if( i < addnum )
			{
					 if( i == 0 ){ if( DXA_DIR_FileNameCmp( DXA, ".",  str ) == 0 ) break; }
				else if( i == 1 ){ if( DXA_DIR_FileNameCmp( DXA, "..", str ) == 0 ) break; }
			}
			else
			{
				name = (char *)( nameTable + file->NameAddress + 4 );
				if( DXA_DIR_FileNameCmp( DXA, name, str ) == 0 ) break;
			}
		}
		FindData->ObjectCount = ( DWORD )i;
		if( i == num + addnum )
			return -1;

		if( FileInfo )
		{
			if( i < addnum )
			{
				switch( i )
				{
				case 0: _STRCPY( TempName, "."  ); break;
				case 1: _STRCPY( TempName, ".." ); break;
				}
				FileInfo->DirFlag = 1;
				FileInfo->Size    = 0;
				_MEMSET( &FileInfo->CreationTime,  0, sizeof( FileInfo->CreationTime  ) );
				_MEMSET( &FileInfo->LastWriteTime, 0, sizeof( FileInfo->LastWriteTime ) );
			}
			else
			{
				name = (char *)( nameTable + file->NameAddress );
				_STRCPY( TempName, name + ((WORD *)name)[0] * 4 + 4 );
				FileInfo->DirFlag = (file->Attributes & FILE_ATTRIBUTE_DIRECTORY) != 0 ? TRUE : FALSE;
				FileInfo->Size = (LONGLONG)file->DataSize;
				_FileTimeToLocalDateData( (FILETIME *)&file->Time.Create,    &FileInfo->CreationTime  );
				_FileTimeToLocalDateData( (FILETIME *)&file->Time.LastWrite, &FileInfo->LastWriteTime );
			}

#ifdef UNICODE
			MBCharToWChar( DXA->Head.CodePage, TempName, ( DXWCHAR * )FileInfo->Name, 260 ) ;
#else
			lstrcpy( FileInfo->Name, TempName );
#endif
		}
	}

	return 0;
}



// A[JCut@Cׂ̍\̂
extern	int	DXA_Initialize( DXARC *DXA )
{
	_MEMSET( DXA, 0, sizeof( DXARC ) ) ;

	// I
	return 0 ;
}

// A[JCut@Cׂ̍\̂̌n
extern int DXA_Terminate( DXARC *DXA )
{
	DXA_CloseArchive( DXA ) ;

	_MEMSET( DXA, 0, sizeof( DXARC ) ) ;

	// I
	return 0 ;
}

// w̃fBNgf[^̈Í( ۂƃɓǂݍ񂾏ꍇp )
static int DXA_DirectoryKeyConv( DXARC *DXA, DXARC_DIRECTORY *Dir )
{
	// C[Wł͂Ȃꍇ̓G[
	if( DXA->MemoryOpenFlag == FALSE )
		return -1 ;

	// o[W 0x0006 Oł͉Ȃ
	if( DXA->V5Flag )
		return 0 ;

	// ÍJn
	{
		DWORD i, FileHeadSize ;
		DXARC_FILEHEAD *File ;

		// i[Ăt@C̐JԂ
		FileHeadSize = DXARC_FILEHEAD_VER6_SIZE ;
		File = ( DXARC_FILEHEAD * )( DXA->Table.FileTable + Dir->FileHeadAddress ) ;
		for( i = 0 ; i < Dir->FileHeadNum ; i ++, File = ( DXARC_FILEHEAD * )( ( BYTE * )File + FileHeadSize ) )
		{
			// fBNgǂŏ𕪊
			if( File->Attributes & FILE_ATTRIBUTE_DIRECTORY )
			{
				// fBNg̏ꍇ͍ċA
				DXA_DirectoryKeyConv( DXA, ( DXARC_DIRECTORY * )( DXA->Table.DirectoryTable + File->DataAddress ) ) ;
			}
			else
			{
				BYTE *DataP ;

				// t@C̏ꍇ͈Í
				
				// f[^ꍇ̂ݏ
				if( File->DataSize != 0 )
				{
					// f[^ʒuZbg
					DataP = ( BYTE * )DXA->MemoryImage + DXA->Head.DataStartAddress + File->DataAddress ;

					// f[^kĂ邩ǂŏ𕪊
					if( File->PressDataSize != NONE_PAL )
					{
						// kĂꍇ
						DXA_KeyConv( DataP, File->PressDataSize, File->DataSize, DXA->Key ) ;
					}
					else
					{
						// kĂȂꍇ
						DXA_KeyConv( DataP, File->DataSize, File->DataSize, DXA->Key ) ;
					}
				}
			}
		}
	}

	// I
	return 0 ;
}

// w̃fBNgf[^̈Í( ۂƃɓǂݍ񂾏ꍇp )
static int DXA_DirectoryKeyConvV5( DXARC *DXA, DXARC_DIRECTORY_VER5 *Dir )
{
	// C[Wł͂Ȃꍇ̓G[
	if( DXA->MemoryOpenFlag == FALSE )
		return -1 ;

	// o[W 0x0005 Oł͉Ȃ
	if( DXA->HeadV5.Version < 0x0005 )
		return 0 ;
	
	// ÍJn
	{
		DWORD i, FileHeadSize ;
		DXARC_FILEHEAD_VER5 *File ;

		// i[Ăt@C̐JԂ
		FileHeadSize = DXA->HeadV5.Version >= 0x0002 ? DXARC_FILEHEAD_VER2_SIZE : DXARC_FILEHEAD_VER1_SIZE ;
		File = ( DXARC_FILEHEAD_VER5 * )( DXA->Table.FileTable + Dir->FileHeadAddress ) ;
		for( i = 0 ; i < Dir->FileHeadNum ; i ++, File = ( DXARC_FILEHEAD_VER5 * )( ( BYTE * )File + FileHeadSize ) )
		{
			// fBNgǂŏ𕪊
			if( File->Attributes & FILE_ATTRIBUTE_DIRECTORY )
			{
				// fBNg̏ꍇ͍ċA
				DXA_DirectoryKeyConvV5( DXA, ( DXARC_DIRECTORY_VER5 * )( DXA->Table.DirectoryTable + File->DataAddress ) ) ;
			}
			else
			{
				BYTE *DataP ;

				// t@C̏ꍇ͈Í
				
				// f[^ꍇ̂ݏ
				if( File->DataSize != 0 )
				{
					// f[^ʒuZbg
					DataP = ( BYTE * )DXA->MemoryImage + DXA->HeadV5.DataStartAddress + File->DataAddress ;

					// f[^kĂ邩ǂŏ𕪊
					if( DXA->HeadV5.Version >= 0x0002 && File->PressDataSize != 0xffffffff )
					{
						// kĂꍇ
						DXA_KeyConv( DataP, File->PressDataSize, File->DataSize, DXA->Key ) ;
					}
					else
					{
						// kĂȂꍇ
						DXA_KeyConv( DataP, File->DataSize, File->DataSize, DXA->Key ) ;
					}
				}
			}
		}
	}

	// I
	return 0 ;
}

// ɂA[JCut@CC[WJ( 0:  -1:s )
extern int DXA_OpenArchiveFromMem( DXARC *DXA, void *ArchiveImage, int ArchiveSize, const char *KeyString )
{
	BYTE *datp ;

	// ɂȂ炩̃A[JCuJĂꍇ̓G[
	if( DXA->WinFilePointer__ != 0 || DXA->MemoryImage != NULL ) return -1 ;

	// ̍쐬
	DXA_KeyCreate( KeyString, DXA->Key ) ;

	// ŏɃwb_̕𔽓]
	_MEMCPY( &DXA->Head, ArchiveImage, DXARC_ID_AND_VERSION_SIZE ) ;
	DXA_KeyConv( &DXA->Head, DXARC_ID_AND_VERSION_SIZE, 0, DXA->Key ) ;

	// hcႤꍇ̓o[WQȑOׂ
	if( DXA->Head.Head != DXAHEAD )
	{
		// o[WQȑOׂ
		_MEMSET( DXA->Key, 0xff, DXA_KEYSTR_LENGTH ) ;

		_MEMCPY( &DXA->Head, ArchiveImage, DXARC_ID_AND_VERSION_SIZE ) ;
		DXA_KeyConv( &DXA->Head, DXARC_ID_AND_VERSION_SIZE, 0, DXA->Key ) ;

		// o[WQȑOłȂꍇ̓G[
		if( DXA->Head.Head != DXAHEAD )
			return -1 ;
	}

	// o[W6ȍ~ǂŏ𕪊
	if( DXA->Head.Version >= 0x0006 )
	{
		DXA->V5Flag = FALSE ;

		DXA->Head.CodePage = 0 ;

		// |C^ۑ
		DXA->MemoryImage = ArchiveImage ;

		// wb_͂
		{
			_MEMCPY( &DXA->Head, ArchiveImage, DXARC_HEAD_VER6_SIZE ) ;
			DXA_KeyConv( &DXA->Head, DXARC_HEAD_VER6_SIZE, 0, DXA->Key ) ;

			// hč
			if( DXA->Head.Head != DXAHEAD ) goto ERR ;
			
			// o[W
			if( DXA->Head.Version > DXAVER ) goto ERR ;

			// R[hy[WZbg
			switch( DXA->Head.CodePage )
			{
			case 949 : DXA->CharSet = DX_CHARSET_HANGEUL ; break ;
			case 950 : DXA->CharSet = DX_CHARSET_BIG5 ;    break ;
			case 936 : DXA->CharSet = DX_CHARSET_GB2312 ;  break ;
			case 932 : DXA->CharSet = DX_CHARSET_SHFTJIS ; break ;
			default :  DXA->CharSet = DX_CHARSET_DEFAULT ; break ;
			}

			// e[ũAhXZbg
			DXA->Table.Top				= (BYTE *)DXA->MemoryImage + DXA->Head.FileNameTableStartAddress ;
			DXA_KeyConv( DXA->Table.Top, DXA->Head.HeadSize, 0, DXA->Key ) ;

			DXA->Table.NameTable		= DXA->Table.Top ;
			DXA->Table.FileTable		= DXA->Table.NameTable + DXA->Head.FileTableStartAddress ;
			DXA->Table.DirectoryTable	= DXA->Table.NameTable + DXA->Head.DirectoryTableStartAddress ;
		}

		// JgfBNg̃Zbg
		DXA->CurrentDirectory = ( DXARC_DIRECTORY * )DXA->Table.DirectoryTable ;

		DXA->MemoryOpenFlag					= TRUE ;			// C[WJĂtO𗧂Ă
		DXA->UserMemoryImageFlag			= TRUE ;			// [U[̃C[WJtO𗧂Ă
		DXA->MemoryImageSize				= ArchiveSize ;		// TCYۑĂ

		// SẴt@Cf[^̈Í
		DXA_DirectoryKeyConv( DXA, ( DXARC_DIRECTORY * )DXA->Table.DirectoryTable ) ;
	}
	else
	{
		DXA->V5Flag = TRUE ;

		// ׂẴf[^𔽓]
		if( DXA->HeadV5.Version < 0x0005 )
		{
			DXA_KeyConv( ArchiveImage, ArchiveSize, 0, DXA->Key ) ;
		}

		// |C^ۑ
		DXA->MemoryImage = ArchiveImage ;
		datp = (BYTE *)ArchiveImage ;

		// wb_͂
		{
			if( DXA->HeadV5.Version >= 0x0005 )
			{
				_MEMCPY( &DXA->HeadV5, datp, DXARC_HEAD_VER3_SIZE ) ;
				DXA_KeyConv( &DXA->HeadV5, DXARC_HEAD_VER3_SIZE, 0, DXA->Key ) ;
			}
			else
			{
				_MEMCPY( &DXA->HeadV5, datp, DXARC_HEAD_VER3_SIZE ) ;
			}
			datp += DXARC_HEAD_VER3_SIZE ;

			// hč
			if( DXA->HeadV5.Head != DXAHEAD ) goto ERR ;
			
			// o[W
			if( DXA->HeadV5.Version > DXAVER_VER5 ) goto ERR ;

			// o[W 4ȏゾR[hy[Wǂݍ
			if( DXA->HeadV5.Version >= 0x0004 )
			{
				DXA->HeadV5.CodePage = *( ( DWORD * )datp ) ;
				if( DXA->HeadV5.Version >= 0x0005 )
				{
					DXA_KeyConv( &DXA->HeadV5.CodePage, 4, DXARC_HEAD_VER3_SIZE, DXA->Key ) ;
				}
				switch( DXA->HeadV5.CodePage )
				{
				case 949 : DXA->CharSet = DX_CHARSET_HANGEUL ; break ;
				case 950 : DXA->CharSet = DX_CHARSET_BIG5 ;    break ;
				case 936 : DXA->CharSet = DX_CHARSET_GB2312 ;  break ;
				case 932 : DXA->CharSet = DX_CHARSET_SHFTJIS ; break ;
				default :  DXA->CharSet = DX_CHARSET_DEFAULT ; break ;
				}
			}
			else
			{
				DXA->HeadV5.CodePage = 0 ;
				DXA->CharSet = DX_CHARSET_DEFAULT ;
			}

			// e[ũAhXZbg
			DXA->Table.Top				= (BYTE *)DXA->MemoryImage + DXA->HeadV5.FileNameTableStartAddress ;
			if( DXA->HeadV5.Version >= 0x0005 )
			{
				DXA_KeyConv( DXA->Table.Top, DXA->HeadV5.HeadSize, 0, DXA->Key ) ;
			}
			DXA->Table.NameTable		= DXA->Table.Top ;
			DXA->Table.FileTable		= DXA->Table.NameTable + DXA->HeadV5.FileTableStartAddress ;
			DXA->Table.DirectoryTable	= DXA->Table.NameTable + DXA->HeadV5.DirectoryTableStartAddress ;
		}

		// JgfBNg̃Zbg
		DXA->CurrentDirectoryV5 = ( DXARC_DIRECTORY_VER5 * )DXA->Table.DirectoryTable ;

		DXA->MemoryOpenFlag					= TRUE ;			// C[WJĂtO𗧂Ă
		DXA->UserMemoryImageFlag			= TRUE ;			// [U[̃C[WJtO𗧂Ă
		DXA->MemoryImageSize				= ArchiveSize ;		// TCYۑĂ

		// SẴt@Cf[^̈Í
		if( DXA->HeadV5.Version >= 0x0005 )
		{
			DXA_DirectoryKeyConvV5( DXA, ( DXARC_DIRECTORY_VER5 * )DXA->Table.DirectoryTable ) ;
		}
	}

	// I
	return 0 ;

ERR :
	if( DXA->V5Flag )
	{
		// ]f[^ɖ߂
		if( DXA->HeadV5.Version < 0x0005 )
		{
			DXA_KeyConv( ArchiveImage, ArchiveSize, 0, DXA->Key ) ;
		}
	}
	
	// I
	return -1 ;
}

// A[JCut@C𓾂( TRUE:Ă  FALSE:ĂȂ )
extern int DXA_CheckIdle( DXARC *DXA )
{
	// 񓯊I[vł͂ȂΓɂ邱Ƃ͂Ȃ
	if( DXA->ASyncOpenFlag == FALSE ) return TRUE ;

	// t@Cǂݍ݂Ă邩ׂ
	if( ReadOnlyFileAccessIdleCheck( DXA->ASyncOpenFilePointer ) == FALSE ) return FALSE ;

	// t@C
	ReadOnlyFileAccessClose( DXA->ASyncOpenFilePointer ) ;
	DXA->ASyncOpenFilePointer = 0;

	// ׂẴf[^𔽓]
	if( DXA->V5Flag == FALSE )
	{
		DXA_DirectoryKeyConv( DXA, ( DXARC_DIRECTORY * )DXA->Table.DirectoryTable ) ;
	}
	else
	{
		if( DXA->HeadV5.Version >= 0x0005 )
		{
			DXA_DirectoryKeyConvV5( DXA, ( DXARC_DIRECTORY_VER5 * )DXA->Table.DirectoryTable ) ;
		}
		else
		{
			DXA_KeyConv( DXA->MemoryImage, DXA->MemoryImageSize, 0, DXA->Key ) ;
		}
	}

	// 񓯊I[vtO|
	DXA->ASyncOpenFlag = FALSE ;

	// I
	return TRUE ;
}

// A[JCut@CJŏɂׂăɓǂݍł珈( 0:  -1:s )
extern int DXA_OpenArchiveFromFileUseMem( DXARC *DXA, const TCHAR *ArchivePath, const char *KeyString , int ASyncThread )
{
	// ɂȂ炩̃A[JCuJĂꍇ̓G[
	if( DXA->WinFilePointer__ != 0 || DXA->MemoryImage ) return -1 ;

	// ̍쐬
	DXA_KeyCreate( KeyString, DXA->Key ) ;

	// wb_ɓǂݍ
	DXA->ASyncOpenFilePointer = 0 ;
	DXA->MemoryImage = NULL ;
	DXA->ASyncOpenFilePointer = ReadOnlyFileAccessOpen( ArchivePath, FALSE, TRUE, FALSE ) ;
	if( DXA->ASyncOpenFilePointer == 0 ) return -1 ;

	// t@CpXۑ
	lstrcpy( DXA->FilePath, ArchivePath ) ;

	// t@C̃TCY擾
	ReadOnlyFileAccessSeek( DXA->ASyncOpenFilePointer, 0L, SEEK_END ) ;
	DXA->MemoryImageSize = ReadOnlyFileAccessTell( DXA->ASyncOpenFilePointer ) ;
	ReadOnlyFileAccessSeek( DXA->ASyncOpenFilePointer, 0L, SEEK_SET ) ;

	// t@C̓eSăɓǂݍވׂ̃̈̊m
	DXA->MemoryImage = DXALLOC( ( size_t )DXA->MemoryImageSize ) ;

	// IDƃo[Wǂݍ
	DXA_KeyConvFileRead( &DXA->Head, DXARC_ID_AND_VERSION_SIZE, DXA->ASyncOpenFilePointer, DXA->Key, 0 ) ;

	// hcႤꍇ̓o[WQȑOׂ
	if( DXA->Head.Head != DXAHEAD )
	{
		// o[WQȑOׂ
		_MEMSET( DXA->Key, 0xff, DXA_KEYSTR_LENGTH ) ;

		ReadOnlyFileAccessSeek( DXA->ASyncOpenFilePointer, 0L, SEEK_SET ) ;
		DXA_KeyConvFileRead( &DXA->Head, DXARC_ID_AND_VERSION_SIZE, DXA->ASyncOpenFilePointer, DXA->Key, 0 ) ;

		// o[WQȑOłȂꍇ̓G[
		if( DXA->Head.Head != DXAHEAD )
			goto ERR ;
	}

	// o[W6ȍ~ǂŏ𕪊
	if( DXA->Head.Version >= 0x0006 )
	{
		DXA->V5Flag = FALSE ;

		// o[W
		if( DXA->Head.Version > DXAVER ) goto ERR ;

		// o[WSȏォǂœǂݍގc̃wb_TCYύX
		DXA_KeyConvFileRead( ( BYTE * )&DXA->Head + DXARC_ID_AND_VERSION_SIZE, DXARC_HEAD_VER6_SIZE - DXARC_ID_AND_VERSION_SIZE, DXA->ASyncOpenFilePointer, DXA->Key, DXARC_ID_AND_VERSION_SIZE ) ;
		switch( DXA->Head.CodePage )
		{
		case 949 : DXA->CharSet = DX_CHARSET_HANGEUL ; break ;
		case 950 : DXA->CharSet = DX_CHARSET_BIG5 ;    break ;
		case 936 : DXA->CharSet = DX_CHARSET_GB2312 ;  break ;
		case 932 : DXA->CharSet = DX_CHARSET_SHFTJIS ; break ;
		default :  DXA->CharSet = DX_CHARSET_DEFAULT ; break ;
		}
		
		// e[ũTCỸmۂ
		DXA->Table.Top = ( BYTE * )DXALLOC( DXA->Head.HeadSize ) ;
		if( DXA->Table.Top == NULL ) goto ERR ;
		
		// e[uɓǂݍ
		ReadOnlyFileAccessSeek( DXA->ASyncOpenFilePointer, DXA->Head.FileNameTableStartAddress, SEEK_SET ) ;
		DXA_KeyConvFileRead( DXA->Table.Top, DXA->Head.HeadSize, DXA->ASyncOpenFilePointer, DXA->Key, 0 ) ;

		// e[ũAhXZbg
		DXA->Table.NameTable		= DXA->Table.Top ;
		DXA->Table.FileTable		= DXA->Table.NameTable + DXA->Head.FileTableStartAddress ;
		DXA->Table.DirectoryTable	= DXA->Table.NameTable + DXA->Head.DirectoryTableStartAddress ;

		// JgfBNg̃Zbg
		DXA->CurrentDirectory = ( DXARC_DIRECTORY * )DXA->Table.DirectoryTable ;
	}
	else
	{
		DXA->V5Flag = TRUE ;

		// o[W
		if( DXA->HeadV5.Version > DXAVER_VER5 ) goto ERR ;

		// o[WSȏォǂœǂݍގc̃wb_TCYύX
		if( DXA->HeadV5.Version >= 0x0004 )
		{
			DXA_KeyConvFileRead( ( BYTE * )&DXA->HeadV5 + DXARC_ID_AND_VERSION_SIZE, DXARC_HEAD_VER4_SIZE - DXARC_ID_AND_VERSION_SIZE, DXA->ASyncOpenFilePointer, DXA->Key, DXARC_ID_AND_VERSION_SIZE ) ;
			switch( DXA->HeadV5.CodePage )
			{
			case 949 : DXA->CharSet = DX_CHARSET_HANGEUL ; break ;
			case 950 : DXA->CharSet = DX_CHARSET_BIG5 ;    break ;
			case 936 : DXA->CharSet = DX_CHARSET_GB2312 ;  break ;
			case 932 : DXA->CharSet = DX_CHARSET_SHFTJIS ; break ;
			default :  DXA->CharSet = DX_CHARSET_DEFAULT ; break ;
			}
		}
		else
		{
			DXA_KeyConvFileRead( ( BYTE * )&DXA->HeadV5 + DXARC_ID_AND_VERSION_SIZE, DXARC_HEAD_VER3_SIZE - DXARC_ID_AND_VERSION_SIZE, DXA->ASyncOpenFilePointer, DXA->Key, DXARC_ID_AND_VERSION_SIZE ) ;
			DXA->HeadV5.CodePage = 0 ;
			DXA->CharSet = DX_CHARSET_DEFAULT ;
		}
		
		// e[ũTCỸmۂ
		DXA->Table.Top = ( BYTE * )DXALLOC( DXA->HeadV5.HeadSize ) ;
		if( DXA->Table.Top == NULL ) goto ERR ;
		
		// e[uɓǂݍ
		ReadOnlyFileAccessSeek( DXA->ASyncOpenFilePointer, DXA->HeadV5.FileNameTableStartAddress, SEEK_SET ) ;
		if( DXA->HeadV5.Version >= 0x0005 )
		{
			DXA_KeyConvFileRead( DXA->Table.Top, DXA->HeadV5.HeadSize, DXA->ASyncOpenFilePointer, DXA->Key, 0 ) ;
		}
		else
		{
			DXA_KeyConvFileRead( DXA->Table.Top, DXA->HeadV5.HeadSize, DXA->ASyncOpenFilePointer, DXA->Key ) ;
		}

		// e[ũAhXZbg
		DXA->Table.NameTable		= DXA->Table.Top ;
		DXA->Table.FileTable		= DXA->Table.NameTable + DXA->HeadV5.FileTableStartAddress ;
		DXA->Table.DirectoryTable	= DXA->Table.NameTable + DXA->HeadV5.DirectoryTableStartAddress ;

		// JgfBNg̃Zbg
		DXA->CurrentDirectoryV5 = ( DXARC_DIRECTORY_VER5 * )DXA->Table.DirectoryTable ;
	}

	// ߂ăt@CۂƓǂݍ
	ReadOnlyFileAccessSeek( DXA->ASyncOpenFilePointer, 0L, SEEK_SET ) ;
	ReadOnlyFileAccessRead( DXA->MemoryImage, ( size_t )DXA->MemoryImageSize, 1, DXA->ASyncOpenFilePointer );

	// t@C񓯊I[vƂƂZbgĂ
	DXA->ASyncOpenFlag = TRUE ;

	DXA->MemoryOpenFlag					= TRUE ;			// C[WJĂtO𗧂Ă
	DXA->UserMemoryImageFlag			= FALSE ;			// [U[̃C[WJ킯ł͂Ȃ̂ŃtO|

	// I[v̏ꍇ͂ŊJÎ҂
	if( ASyncThread == FALSE )
	{
		while( DXA_CheckIdle( DXA ) == FALSE ) Sleep(0);
	}

	// I
	return 0 ;

ERR :
	if( DXA->ASyncOpenFilePointer )
	{
		ReadOnlyFileAccessClose( DXA->ASyncOpenFilePointer );
		DXA->ASyncOpenFilePointer = 0;
	}

	if( DXA->MemoryImage )
	{
		DXFREE( DXA->MemoryImage );
		DXA->MemoryImage = 0;
	}

	DXA->ASyncOpenFlag = FALSE ;

	// I
	return -1 ;
}

// A[JCut@CJ( 0:  -1:s )
extern int DXA_OpenArchiveFromFile( DXARC *DXA, const TCHAR *ArchivePath, const char *KeyString )
{
	// ɂȂ炩̃A[JCuJĂꍇ̓G[
	if( DXA->WinFilePointer__ != 0 || DXA->MemoryImage ) return -1 ;

	// wb_̏
	_MEMSET( &DXA->Head, 0, sizeof( DXA->Head ) ) ;

	// A[JCut@CJƎ݂
	DXA->WinFilePointer__ = ReadOnlyFileAccessOpen( ArchivePath, FALSE, TRUE, FALSE ) ;
	if( DXA->WinFilePointer__ == 0 ) return -1 ;

	// t@CpXۑ
	lstrcpy( DXA->FilePath, ArchivePath ) ;

	// ̍쐬
	DXA_KeyCreate( KeyString, DXA->Key ) ;

	// hcƃo[Wԍǂݍ
	DXA_KeyConvFileRead( &DXA->Head, DXARC_ID_AND_VERSION_SIZE, DXA->WinFilePointer__, DXA->Key, 0 ) ;

	// hč
	if( DXA->Head.Head != DXAHEAD )
	{
		// o[WQȑOׂ
		_MEMSET( DXA->Key, 0xff, DXA_KEYSTR_LENGTH ) ;

		ReadOnlyFileAccessSeek( DXA->WinFilePointer__, 0L, SEEK_SET ) ;
		DXA_KeyConvFileRead( &DXA->Head, DXARC_ID_AND_VERSION_SIZE, DXA->WinFilePointer__, DXA->Key, 0 ) ;

		// o[WQȑOłȂꍇ̓G[
		if( DXA->Head.Head != DXAHEAD )
			goto ERR ;
	}

	// o[W6ȍ~ǂŏ𕪊
	if( DXA->Head.Version >= 0x0006 )
	{
		DXA->V5Flag = FALSE ;

		// o[W
		if( DXA->Head.Version > DXAVER ) goto ERR ;

		// o[WSȏォǂœǂݍގc̃wb_TCYύX
		DXA_KeyConvFileRead( ( BYTE * )&DXA->Head + DXARC_ID_AND_VERSION_SIZE, DXARC_HEAD_VER6_SIZE - DXARC_ID_AND_VERSION_SIZE, DXA->WinFilePointer__, DXA->Key, DXARC_ID_AND_VERSION_SIZE ) ;
		switch( DXA->Head.CodePage )
		{
		case 949 : DXA->CharSet = DX_CHARSET_HANGEUL ; break ;
		case 950 : DXA->CharSet = DX_CHARSET_BIG5 ;    break ;
		case 936 : DXA->CharSet = DX_CHARSET_GB2312 ;  break ;
		case 932 : DXA->CharSet = DX_CHARSET_SHFTJIS ; break ;
		default :  DXA->CharSet = DX_CHARSET_DEFAULT ; break ;
		}

		// e[ũTCỸmۂ
		DXA->Table.Top = ( BYTE * )DXALLOC( DXA->Head.HeadSize ) ;
		if( DXA->Table.Top == NULL ) goto ERR ;
		
		// e[uɓǂݍ
		ReadOnlyFileAccessSeek( DXA->WinFilePointer__, DXA->Head.FileNameTableStartAddress, SEEK_SET ) ;
		DXA_KeyConvFileRead( DXA->Table.Top, DXA->HeadV5.HeadSize, DXA->WinFilePointer__, DXA->Key, 0 ) ;

		// e[ũAhXZbg
		DXA->Table.NameTable		= DXA->Table.Top ;
		DXA->Table.FileTable		= DXA->Table.NameTable + DXA->Head.FileTableStartAddress ;
		DXA->Table.DirectoryTable	= DXA->Table.NameTable + DXA->Head.DirectoryTableStartAddress ;

		// JgfBNg̃Zbg
		DXA->CurrentDirectory = ( DXARC_DIRECTORY * )DXA->Table.DirectoryTable ;
	}
	else
	{
		DXA->V5Flag = TRUE ;

		// o[W
		if( DXA->HeadV5.Version > DXAVER_VER5 ) goto ERR ;

		// o[WSȏォǂœǂݍގc̃wb_TCYύX
		if( DXA->HeadV5.Version >= 0x0004 )
		{
			DXA_KeyConvFileRead( ( BYTE * )&DXA->HeadV5 + DXARC_ID_AND_VERSION_SIZE, DXARC_HEAD_VER4_SIZE - DXARC_ID_AND_VERSION_SIZE, DXA->WinFilePointer__, DXA->Key, DXARC_ID_AND_VERSION_SIZE ) ;
			switch( DXA->HeadV5.CodePage )
			{
			case 949 : DXA->CharSet = DX_CHARSET_HANGEUL ; break ;
			case 950 : DXA->CharSet = DX_CHARSET_BIG5 ;    break ;
			case 936 : DXA->CharSet = DX_CHARSET_GB2312 ;  break ;
			case 932 : DXA->CharSet = DX_CHARSET_SHFTJIS ; break ;
			default :  DXA->CharSet = DX_CHARSET_DEFAULT ; break ;
			}
		}
		else
		{
			DXA_KeyConvFileRead( ( BYTE * )&DXA->HeadV5 + DXARC_ID_AND_VERSION_SIZE, DXARC_HEAD_VER3_SIZE - DXARC_ID_AND_VERSION_SIZE, DXA->WinFilePointer__, DXA->Key, DXARC_ID_AND_VERSION_SIZE ) ;
			DXA->HeadV5.CodePage = 0 ;
			DXA->CharSet = DX_CHARSET_DEFAULT ;
		}

		// e[ũTCỸmۂ
		DXA->Table.Top = ( BYTE * )DXALLOC( DXA->HeadV5.HeadSize ) ;
		if( DXA->Table.Top == NULL ) goto ERR ;
		
		// e[uɓǂݍ
		ReadOnlyFileAccessSeek( DXA->WinFilePointer__, DXA->HeadV5.FileNameTableStartAddress, SEEK_SET ) ;
		if( DXA->HeadV5.Version >= 0x0005 )
		{
			DXA_KeyConvFileRead( DXA->Table.Top, DXA->HeadV5.HeadSize, DXA->WinFilePointer__, DXA->Key, 0 ) ;
		}
		else
		{
			DXA_KeyConvFileRead( DXA->Table.Top, DXA->HeadV5.HeadSize, DXA->WinFilePointer__, DXA->Key ) ;
		}

		// e[ũAhXZbg
		DXA->Table.NameTable		= DXA->Table.Top ;
		DXA->Table.FileTable		= DXA->Table.NameTable + DXA->HeadV5.FileTableStartAddress ;
		DXA->Table.DirectoryTable	= DXA->Table.NameTable + DXA->HeadV5.DirectoryTableStartAddress ;

		// JgfBNg̃Zbg
		DXA->CurrentDirectoryV5 = ( DXARC_DIRECTORY_VER5 * )DXA->Table.DirectoryTable ;
	}

	DXA->MemoryOpenFlag					= FALSE ;			// C[WJĂtO|
	DXA->UserMemoryImageFlag			= FALSE ;			// [U[̃C[WJ킯ł͂Ȃ̂ŃtO|

	// I
	return 0 ;

ERR :
	if( DXA->WinFilePointer__ != 0 )
	{
		ReadOnlyFileAccessClose( DXA->WinFilePointer__ ) ;
		DXA->WinFilePointer__ = 0 ;
	}

	if( DXA->Table.Top != NULL )
	{
		DXFREE( DXA->Table.Top ) ;
		DXA->Table.Top = NULL ;
	}
	
	// I
	return -1 ;
}

// A[JCut@C
extern int DXA_CloseArchive( DXARC *DXA )
{
	// ɕĂ牽I
	if( DXA->WinFilePointer__ == 0 && DXA->MemoryImage == NULL ) return 0 ;

	// 񓯊I[v̏ꍇ͂ŊJÎ҂
	if( DXA->ASyncOpenFlag == TRUE )
	{
		while( DXA_CheckIdle( DXA ) == FALSE ) Sleep(0);
	}

	// JĂ邩ǂŏ𕪊
	if( DXA->MemoryOpenFlag == TRUE )
	{
		// A[JCuvOɓǂݍ񂾏ꍇƂłȂꍇŏ𕪊
		if( DXA->UserMemoryImageFlag == TRUE )
		{
			// [U[nꂽf[^ꍇ

			// ]f[^ɖ߂
			if( DXA->V5Flag == FALSE )
			{
				DXA_DirectoryKeyConv( DXA, ( DXARC_DIRECTORY * )DXA->Table.DirectoryTable ) ;
				DXA_KeyConv( DXA->Table.Top, DXA->Head.HeadSize, 0, DXA->Key ) ;
			}
			else
			{
				if( DXA->HeadV5.Version >= 0x0005 )
				{
					DXA_DirectoryKeyConvV5( DXA, ( DXARC_DIRECTORY_VER5 * )DXA->Table.DirectoryTable ) ;
					DXA_KeyConv( DXA->Table.Top, DXA->HeadV5.HeadSize, 0, DXA->Key ) ;
				}
				else
				{
					DXA_KeyConv( DXA->MemoryImage, DXA->MemoryImageSize, 0, DXA->Key ) ;
				}
			}
		}
		else
		{
			// A[JCuvOɓǂݍ񂾏ꍇ

			// mۂĂJ
			DXFREE( DXA->Table.Top ) ;
			DXFREE( DXA->MemoryImage ) ;
		}
	}
	else
	{
		// A[JCut@C
		ReadOnlyFileAccessClose( DXA->WinFilePointer__ ) ;

		// e[ui[Ă̈
		DXFREE( DXA->Table.Top ) ;
	}

	// 
	_MEMSET( DXA, 0, sizeof( DXARC ) ) ;

	// I
	return 0 ;
}

// A[JCũfBNgpXύX( 0:  -1:s )
static int DXA_ChangeCurrentDirectoryFast( DXARC *DXA, DXARC_SEARCHDATA *SearchData )
{
	int i, j, k, Num ;
	BYTE *NameData, *PathData ;
	WORD PackNum, Parity ;
	DWORD FileHeadSize ;

	// 񓯊I[v̏ꍇ͂ŊJÎ҂
	if( DXA->ASyncOpenFlag == TRUE )
	{
		while( DXA_CheckIdle( DXA ) == FALSE ) Sleep(0);
	}

	PackNum  = SearchData->PackNum ;
	Parity   = SearchData->Parity ;
	PathData = SearchData->FileName ;

	// JgfBNg瓯̃fBNgT
	if( DXA->V5Flag )
	{
		DXARC_FILEHEAD_VER5 *FileH ;

		FileH = ( DXARC_FILEHEAD_VER5 * )( DXA->Table.FileTable + DXA->CurrentDirectoryV5->FileHeadAddress ) ;
		Num = (int)DXA->CurrentDirectoryV5->FileHeadNum ;
		FileHeadSize = DXA->HeadV5.Version >= 0x0002 ? DXARC_FILEHEAD_VER2_SIZE : DXARC_FILEHEAD_VER1_SIZE ;
		for( i = 0 ; i < Num ; i ++, FileH = (DXARC_FILEHEAD_VER5 *)( (BYTE *)FileH + FileHeadSize ) )
		{
			// fBNg`FbN
			if( ( FileH->Attributes & FILE_ATTRIBUTE_DIRECTORY ) == 0 ) continue ;

			// 񐔂ƃpeB`FbN
			NameData = DXA->Table.NameTable + FileH->NameAddress ;
			if( PackNum != ((WORD *)NameData)[0] || Parity != ((WORD *)NameData)[1] ) continue ;

			// `FbN
			NameData += 4 ;
			for( j = 0, k = 0 ; j < PackNum ; j ++, k += 4 )
				if( *((DWORD *)&PathData[k]) != *((DWORD *)&NameData[k]) ) break ;

			// KfBNg炱ŏI
			if( PackNum == j ) break ;
		}

		// G[
		if( i == Num ) return -1 ;

		// ݂JgfBNgύX
		DXA->CurrentDirectoryV5 = ( DXARC_DIRECTORY_VER5 * )( DXA->Table.DirectoryTable + FileH->DataAddress ) ;
	}
	else
	{
		DXARC_FILEHEAD *FileH ;

		FileH = ( DXARC_FILEHEAD * )( DXA->Table.FileTable + DXA->CurrentDirectory->FileHeadAddress ) ;
		Num = (int)DXA->CurrentDirectory->FileHeadNum ;
		FileHeadSize = DXARC_FILEHEAD_VER6_SIZE ;
		for( i = 0 ; i < Num ; i ++, FileH = (DXARC_FILEHEAD *)( (BYTE *)FileH + FileHeadSize ) )
		{
			// fBNg`FbN
			if( ( FileH->Attributes & FILE_ATTRIBUTE_DIRECTORY ) == 0 ) continue ;

			// 񐔂ƃpeB`FbN
			NameData = DXA->Table.NameTable + FileH->NameAddress ;
			if( PackNum != ((WORD *)NameData)[0] || Parity != ((WORD *)NameData)[1] ) continue ;

			// `FbN
			NameData += 4 ;
			for( j = 0, k = 0 ; j < PackNum ; j ++, k += 4 )
				if( *((DWORD *)&PathData[k]) != *((DWORD *)&NameData[k]) ) break ;

			// KfBNg炱ŏI
			if( PackNum == j ) break ;
		}

		// G[
		if( i == Num ) return -1 ;

		// ݂JgfBNgύX
		DXA->CurrentDirectory = ( DXARC_DIRECTORY * )( DXA->Table.DirectoryTable + FileH->DataAddress ) ;
	}

	// I
	return 0 ;
}

// A[JCũfBNgpXύX( 0:  -1:s )
extern int DXA_ChangeCurrentDir( DXARC *DXA, const char *DirPath )
{
	return DXA_ChangeCurrentDirectoryBase( DXA, DirPath, true ) ;
}

// A[JCũfBNgpXύX( 0:  -1:s )
static int DXA_ChangeCurrentDirectoryBase( DXARC *DXA, const char *DirectoryPath, bool ErrorIsDirectoryReset, DXARC_SEARCHDATA *LastSearchData )
{
	DXARC_DIRECTORY *OldDir ;
	DXARC_SEARCHDATA SearchData ;

	// 񓯊I[v̏ꍇ͂ŊJÎ҂
	if( DXA->ASyncOpenFlag == TRUE )
	{
		while( DXA_CheckIdle( DXA ) == FALSE ) Sleep(0);
	}

	// ɗ܂pX疳
	if( _STRCMP( DirectoryPath, "." ) == 0 ) return 0 ;

	// w\ or /x̏ꍇ̓[gfBNgɖ߂
	if( _STRCMP( DirectoryPath, "\\" ) == 0 || _STRCMP( DirectoryPath, "/" ) == 0 )
	{
		if( DXA->V5Flag )
		{
			DXA->CurrentDirectoryV5 = ( DXARC_DIRECTORY_VER5 * )DXA->Table.DirectoryTable ;
		}
		else
		{
			DXA->CurrentDirectory   = ( DXARC_DIRECTORY      * )DXA->Table.DirectoryTable ;
		}
		return 0 ;
	}

	// ɈpX珈𕪊
	if( _STRCMP( DirectoryPath, ".." ) == 0 )
	{
		if( DXA->V5Flag )
		{
			// [gfBNgɋG[
			if( DXA->CurrentDirectoryV5->ParentDirectoryAddress == 0xffffffff ) return -1 ;
			
			// efBNg炻Ɉڂ
			DXA->CurrentDirectoryV5 = ( DXARC_DIRECTORY_VER5 * )( DXA->Table.DirectoryTable + DXA->CurrentDirectoryV5->ParentDirectoryAddress ) ;
		}
		else
		{
			// [gfBNgɋG[
			if( DXA->CurrentDirectory->ParentDirectoryAddress == NONE_PAL ) return -1 ;
			
			// efBNg炻Ɉڂ
			DXA->CurrentDirectory   = ( DXARC_DIRECTORY      * )( DXA->Table.DirectoryTable + DXA->CurrentDirectory->ParentDirectoryAddress ) ;
		}
		return 0 ;
	}

	// ȊȌꍇ͎w̖ÕfBNgT
	
	// ύXȑÕfBNgۑĂ
	OldDir = DXA->CurrentDirectory ;

	// pXɁw\x邩ǂŏ𕪊
	if( _STRCHR( DirectoryPath, '\\' ) == NULL && _STRCHR( DirectoryPath, '/' ) == NULL )
	{
		// t@Cp̌`ɕϊ
		DXA_ConvSearchData( DXA, &SearchData, DirectoryPath, NULL ) ;

		// fBNgύX
		if( DXA_ChangeCurrentDirectoryFast( DXA, &SearchData ) < 0 ) goto ERR ;
	}
	else
	{
		// \ or / ꍇ͌qfBNgÂύXĂ䂭
		int Point, StrLength ;

		Point = 0 ;
		// [v
		for(;;)
		{
			// 擾
			DXA_ConvSearchData( DXA, &SearchData, &DirectoryPath[Point], &StrLength ) ;
			Point += StrLength ;

			// [ \ or / ꍇ̓[gfBNgɗƂ
			if( StrLength == 0 && ( DirectoryPath[Point] == '\\' || DirectoryPath[Point] == '/' ) )
			{
				DXA_ChangeCurrentDirectoryBase( DXA, "\\", false ) ;
			}
			else
			{
				// ȊȌꍇ͕ʂɃfBNgύX
				if( DXA_ChangeCurrentDirectoryFast( DXA, &SearchData ) < 0 )
				{
					// G[NāAXɃG[NɌ̃fBNgɖ߂
					// tOĂꍇ͌̃fBNgɖ߂
					if( ErrorIsDirectoryReset == true ) DXA->CurrentDirectory = OldDir ;

					// G[I
					goto ERR ;
				}
			}

			// I[ŏIꍇ̓[v甲
			// ͂ \ or / Ȃꍇ[v甲
			if( DirectoryPath[Point] == '\0' ||
				( ( DirectoryPath[Point] == '\\' && DirectoryPath[Point+1] == '\0' ) ||
				  ( DirectoryPath[Point] == '/' && DirectoryPath[Point+1] == '\0' ) ) ) break ;
			Point ++ ;
		}
	}

	if( LastSearchData != NULL )
	{
		_MEMCPY( LastSearchData->FileName, SearchData.FileName, SearchData.PackNum * 4 ) ;
		LastSearchData->Parity  = SearchData.Parity ;
		LastSearchData->PackNum = SearchData.PackNum ;
	}

	// I
	return 0 ;

ERR:
	if( LastSearchData != NULL )
	{
		_MEMCPY( LastSearchData->FileName, SearchData.FileName, SearchData.PackNum * 4 ) ;
		LastSearchData->Parity  = SearchData.Parity ;
		LastSearchData->PackNum = SearchData.PackNum ;
	}

	// G[I
	return -1 ;
}
		
// A[JCũJgfBNgpX擾
extern int DXA_GetCurrentDir( DXARC *DXA, char *DirPathBuffer, int BufferSize )
{
	char DirPath[256] ;
	int Depth, i ;

	// 񓯊I[v̏ꍇ͂ŊJÎ҂
	if( DXA->ASyncOpenFlag == TRUE )
	{
		while( DXA_CheckIdle( DXA ) == FALSE ) Sleep(0);
	}

	if( DXA->V5Flag )
	{
		DXARC_DIRECTORY_VER5 *Dir[200], *DirTempP ;

		// [gfBNgɒ܂Ō
		Depth = 0 ;
		DirTempP = DXA->CurrentDirectoryV5 ;
		while( DirTempP->DirectoryAddress != 0xffffffff && DirTempP->DirectoryAddress != 0 )
		{
			Dir[Depth] = DirTempP ;
			DirTempP = ( DXARC_DIRECTORY_VER5 * )( DXA->Table.DirectoryTable + DirTempP->ParentDirectoryAddress ) ;
			Depth ++ ;
		}
		
		// pXA
		DirPath[0] = '\0' ;
		for( i = Depth - 1 ; i >= 0 ; i -- )
		{
			_STRCAT( DirPath, "\\" ) ;
			_STRCAT( DirPath, (char *)DXA->Table.NameTable + ((DXARC_FILEHEAD_VER5 *)( DXA->Table.FileTable + Dir[i]->DirectoryAddress ))->NameAddress ) ;
		}
	}
	else
	{
		DXARC_DIRECTORY *Dir[200], *DirTempP ;

		// [gfBNgɒ܂Ō
		Depth = 0 ;
		DirTempP = DXA->CurrentDirectory ;
		while( DirTempP->DirectoryAddress != 0xffffffff && DirTempP->DirectoryAddress != 0 )
		{
			Dir[Depth] = DirTempP ;
			DirTempP = ( DXARC_DIRECTORY * )( DXA->Table.DirectoryTable + DirTempP->ParentDirectoryAddress ) ;
			Depth ++ ;
		}
		
		// pXA
		DirPath[0] = '\0' ;
		for( i = Depth - 1 ; i >= 0 ; i -- )
		{
			_STRCAT( DirPath, "\\" ) ;
			_STRCAT( DirPath, (char *)DXA->Table.NameTable + ((DXARC_FILEHEAD *)( DXA->Table.FileTable + Dir[i]->DirectoryAddress ))->NameAddress ) ;
		}
	}

	// obt@̒OAȂƂ̓fBNg̒Ԃ
	if( BufferSize == 0 || BufferSize < (int)lstrlenA( DirPath ) )
	{
		return lstrlenA( DirPath ) + 1 ;
	}
	else
	{
		// fBNgobt@ɓ]
		_STRCPY( DirPathBuffer, DirPath ) ;
	}

	// I
	return 0 ;
}

// A[JCũIuWFNg( -1:G[ -1ȊO:DXAnh )
extern DWORD_PTR DXA_FindFirst( DXARC *DXA, const char *FilePath, FILEINFO *Buffer )
{
	DXA_FINDDATA *find;
	char Dir[256], Name[256];

	// 񓯊I[v̏ꍇ͂ŊJÎ҂
	if( DXA->ASyncOpenFlag == TRUE )
	{
		while( DXA_CheckIdle( DXA ) == FALSE ) Sleep(0);
	}

	// ̊m
	find = (DXA_FINDDATA *)DXALLOC( sizeof( *find ) );
	if( find == NULL ) return ( DWORD_PTR )-1;

	find->Container = DXA;
	DXA_DIR_AnalysisFileNameAndDirPath( DXA, FilePath, Name, Dir );

	// Sđ啶ɂ
	_STRUPR( Dir );
	_STRUPR( Name );

	// Ώۂ̃fBNg擾
	if( Dir[0] == '\0' )
	{
		find->Directory = DXA->CurrentDirectory;
	}
	else
	{
		DXARC_DIRECTORY *OldDir;

		OldDir = DXA->CurrentDirectory;

		// w̃fBNgꍇ̓G[
		if( DXA_ChangeCurrentDirectoryBase( DXA, Dir, false ) == -1 )
		{
			DXFREE( find );
			return ( DWORD_PTR )-1;
		}

		find->Directory = DXA->CurrentDirectory;
		DXA->CurrentDirectory = OldDir;
	}

	find->ObjectCount = 0;
	_STRCPY( find->SearchStr, Name );

	// Kŏ̃t@C
	if( DXA_FindProcess( find, Buffer ) == -1 )
	{
		DXFREE( find );
		return ( DWORD_PTR )-1;
	}
	find->ObjectCount ++ ;

	// nhԂ
	return (DWORD_PTR)find;
}

// A[JCũIuWFNg( -1:G[ 0: )
extern int DXA_FindNext( DWORD_PTR DxaFindHandle, FILEINFO *Buffer )
{
	DXA_FINDDATA *find;

	find = (DXA_FINDDATA *)DxaFindHandle;
	if( DXA_FindProcess( find, Buffer ) == -1 ) return -1;
	find->ObjectCount ++ ;

	return 0;
}

// A[JCũIuWFNgI
extern int DXA_FindClose( DWORD_PTR DxaFindHandle )
{
	DXA_FINDDATA *find;

	find = (DXA_FINDDATA *)DxaFindHandle;
	DXFREE( find );

	return 0;
}

// A[JCut@C̎w̃t@Cɓǂݍ( -1:G[ 0ȏ:t@CTCY )
extern int DXA_LoadFile( DXARC *DXA, const char *FilePath, void *Buffer, ULONGLONG BufferSize )
{
	// 񓯊I[v̏ꍇ͂ŊJÎ҂
	if( DXA->ASyncOpenFlag == TRUE )
	{
		while( DXA_CheckIdle( DXA ) == FALSE ) Sleep(0);
	}

	if( DXA->V5Flag )
	{
		DXARC_FILEHEAD_VER5 *FileH ;

		// w̃t@C̏𓾂
		FileH = DXA_GetFileInfoV5( DXA, FilePath ) ;
		if( FileH == NULL ) return -1 ;

		// t@CTCYĂ邩ׂAĂȂAobt@A̓TCYOTCYԂ
		if( BufferSize < FileH->DataSize || BufferSize == 0 || Buffer == NULL )
		{
			return ( int )FileH->DataSize ;
		}
		
		// Ăꍇ̓obt@[ɓǂݍ

		// t@CkĂ邩ǂŏ𕪊
		if( DXA->HeadV5.Version >= 0x0002 && FileH->PressDataSize != 0xffffffff )
		{
			// kĂꍇ

			// ɓǂݍł邩ǂŏ𕪊
			if( DXA->MemoryOpenFlag == TRUE )
			{
				// ̈kf[^𓀂
				DXA_Decode( (BYTE *)DXA->MemoryImage + DXA->HeadV5.DataStartAddress + FileH->DataAddress, Buffer ) ;
			}
			else
			{
				void *temp ;

				// kf[^ɓǂݍł𓀂

				// kf[^܂郁̈̊m
				temp = DXALLOC( FileH->PressDataSize ) ;

				// kf[^̓ǂݍ
				ReadOnlyFileAccessSeek( DXA->WinFilePointer__, DXA->HeadV5.DataStartAddress + FileH->DataAddress, SEEK_SET ) ;
				if( DXA->HeadV5.Version >= 0x0005 )
				{
					DXA_KeyConvFileRead( temp, FileH->PressDataSize, DXA->WinFilePointer__, DXA->Key, FileH->DataSize ) ;
				}
				else
				{
					DXA_KeyConvFileRead( temp, FileH->PressDataSize, DXA->WinFilePointer__, DXA->Key ) ;
				}
				
				// 
				DXA_Decode( temp, Buffer ) ;
				
				// ̉
				DXFREE( temp ) ;
			}
		}
		else
		{
			if( DXA->MemoryOpenFlag == TRUE )
			{
				// Rs[
				_MEMCPY( Buffer, (BYTE *)DXA->MemoryImage + DXA->HeadV5.DataStartAddress + FileH->DataAddress, FileH->DataSize ) ;
			}
			else
			{
				// t@C|C^ړ
				ReadOnlyFileAccessSeek( DXA->WinFilePointer__, DXA->HeadV5.DataStartAddress + FileH->DataAddress, SEEK_SET ) ;

				// ǂݍ
				if( DXA->HeadV5.Version >= 0x0005 )
				{
					DXA_KeyConvFileRead( Buffer, FileH->DataSize, DXA->WinFilePointer__, DXA->Key, FileH->DataSize ) ;
				}
				else
				{
					DXA_KeyConvFileRead( Buffer, FileH->DataSize, DXA->WinFilePointer__, DXA->Key ) ;
				}
			}
		}
	}
	else
	{
		DXARC_FILEHEAD *FileH ;

		// w̃t@C̏𓾂
		FileH = DXA_GetFileInfo( DXA, FilePath ) ;
		if( FileH == NULL ) return -1 ;

		// t@CTCYĂ邩ׂAĂȂAobt@A̓TCYOTCYԂ
		if( BufferSize < FileH->DataSize || BufferSize == 0 || Buffer == NULL )
		{
			return ( int )FileH->DataSize ;
		}
		
		// Ăꍇ̓obt@[ɓǂݍ

		// t@CkĂ邩ǂŏ𕪊
		if( FileH->PressDataSize != NONE_PAL )
		{
			// kĂꍇ

			// ɓǂݍł邩ǂŏ𕪊
			if( DXA->MemoryOpenFlag == TRUE )
			{
				// ̈kf[^𓀂
				DXA_Decode( (BYTE *)DXA->MemoryImage + DXA->Head.DataStartAddress + FileH->DataAddress, Buffer ) ;
			}
			else
			{
				void *temp ;

				// kf[^ɓǂݍł𓀂

				// kf[^܂郁̈̊m
				temp = DXALLOC( ( size_t )FileH->PressDataSize ) ;

				// kf[^̓ǂݍ
				ReadOnlyFileAccessSeek( DXA->WinFilePointer__, DXA->Head.DataStartAddress + FileH->DataAddress, SEEK_SET ) ;
				DXA_KeyConvFileRead( temp, FileH->PressDataSize, DXA->WinFilePointer__, DXA->Key, ( LONGLONG )FileH->DataSize ) ;
				
				// 
				DXA_Decode( temp, Buffer ) ;
				
				// ̉
				DXFREE( temp ) ;
			}
		}
		else
		{
			if( DXA->MemoryOpenFlag == TRUE )
			{
				// Rs[
				_MEMCPY( Buffer, (BYTE *)DXA->MemoryImage + DXA->Head.DataStartAddress + FileH->DataAddress, ( size_t )FileH->DataSize ) ;
			}
			else
			{
				// t@C|C^ړ
				ReadOnlyFileAccessSeek( DXA->WinFilePointer__, DXA->Head.DataStartAddress + FileH->DataAddress, SEEK_SET ) ;

				// ǂݍ
				DXA_KeyConvFileRead( Buffer, FileH->DataSize, DXA->WinFilePointer__, DXA->Key, FileH->DataSize ) ;
			}
		}
	}
	
	// I
	return 0 ;
}

// A[JCut@Cɓǂݍ񂾏ꍇ̃t@CC[Wi[Ă擪AhX擾( DXA_OpenArchiveFromFileUseMem Ⴕ DXA_OpenArchiveFromMem ŊJꍇɗL )
extern void *DXA_GetFileImage( DXARC *DXA )
{
	// 񓯊I[v̏ꍇ͂ŊJÎ҂
	if( DXA->ASyncOpenFlag == TRUE )
	{
		while( DXA_CheckIdle( DXA ) == FALSE ) Sleep(0);
	}

	// C[WJĂȂG[
	if( DXA->MemoryOpenFlag == FALSE ) return NULL ;

	// 擪AhXԂ
	return DXA->MemoryImage ;
}

// A[JCut@C̎w̃t@C̃t@C̈ʒuƃt@C̑傫𓾂( -1:G[ )
extern int DXA_GetFileInfo( DXARC *DXA, const char *FilePath, int *Position, int *Size )
{
	// 񓯊I[v̏ꍇ͂ŊJÎ҂
	if( DXA->ASyncOpenFlag == TRUE )
	{
		while( DXA_CheckIdle( DXA ) == FALSE ) Sleep(0);
	}

	if( DXA->V5Flag )
	{
		DXARC_FILEHEAD_VER5 *FileH ;

		// w̃t@C̏𓾂
		FileH = DXA_GetFileInfoV5( DXA, FilePath ) ;
		if( FileH == NULL ) return -1 ;

		// t@C̃f[^ʒuƃt@CTCYۑ
		if( Position != NULL ) *Position = DXA->HeadV5.DataStartAddress + FileH->DataAddress ;
		if( Size     != NULL ) *Size     = FileH->DataSize ;
	}
	else
	{
		DXARC_FILEHEAD *FileH ;

		// w̃t@C̏𓾂
		FileH = DXA_GetFileInfo( DXA, FilePath ) ;
		if( FileH == NULL ) return -1 ;

		// t@C̃f[^ʒuƃt@CTCYۑ
		if( Position != NULL ) *Position = ( int )( DXA->Head.DataStartAddress + FileH->DataAddress ) ;
		if( Size     != NULL ) *Size     = ( int )( FileH->DataSize ) ;
	}

	// I
	return 0 ;
}



// A[JCut@C̃t@CJ(t@CƂ͕KvȂ)
extern int DXA_STREAM_Initialize( DXARC_STREAM *DXAStream, DXARC *DXA, const char *FilePath, int UseASyncReadFlag )
{
	// 񓯊I[v̏ꍇ͂ŊJÎ҂
	if( DXA->ASyncOpenFlag == TRUE )
	{
		while( DXA_CheckIdle( DXA ) == FALSE ) Sleep(0);
	}

	// f[^̃Zbg
	DXAStream->Archive          = DXA ;
	DXAStream->EOFFlag          = FALSE ;
	DXAStream->FilePoint        = 0 ;
	DXAStream->DecodeDataBuffer = NULL ;
	DXAStream->DecodeTempBuffer = NULL ;
	DXAStream->UseASyncReadFlag = UseASyncReadFlag ;
	DXAStream->ASyncState       = DXARC_STREAM_ASYNCSTATE_IDLE ;

	// A[JCut@C̃t@C|C^쐬
	DXAStream->WinFilePointer = ReadOnlyFileAccessOpen( DXA->FilePath, FALSE, TRUE, FALSE ) ;
	if( DXAStream->WinFilePointer == 0 )
		return -1 ;

	if( DXA->V5Flag )
	{
		DXARC_FILEHEAD_VER5 *FileH ;

		// w̃t@C̏𓾂
		FileH = DXA_GetFileInfoV5( DXA, FilePath ) ;
		if( FileH == NULL )
		{
			ReadOnlyFileAccessClose( DXAStream->WinFilePointer ) ;
			DXAStream->WinFilePointer = 0 ;
			return -1 ;
		}

		// t@CZbg
		DXAStream->FileHeadV5 = FileH ;

		// t@CkĂꍇ͂œǂݍŉ𓀂Ă܂
		if( DXA->HeadV5.Version >= 0x0002 && FileH->PressDataSize != 0xffffffff )
		{
			// 𓀃f[^܂郁̈̊m
			DXAStream->DecodeDataBuffer = DXALLOC( FileH->DataSize ) ;

			// ɓǂݍ܂Ă邩ǂŏ𕪊
			if( DXA->MemoryOpenFlag == TRUE )
			{
				// 
				DXA_Decode( (BYTE *)DXA->MemoryImage + DXA->HeadV5.DataStartAddress + FileH->DataAddress, DXAStream->DecodeDataBuffer ) ;
			}
			else
			{
				// kf[^܂郁̈̊m
				DXAStream->DecodeTempBuffer = DXALLOC( FileH->PressDataSize ) ;

				// kf[^̓ǂݍ
				DXAStream->ASyncReadFileAddress = DXA->HeadV5.DataStartAddress + FileH->DataAddress;
				ReadOnlyFileAccessSeek( DXAStream->WinFilePointer, DXAStream->ASyncReadFileAddress, SEEK_SET ) ;

				// 񓯊̏ꍇ͓ǂݍ݂ƌʁXɍs
				if( DXAStream->UseASyncReadFlag == TRUE )
				{
					// t@Cǂݍ
					ReadOnlyFileAccessRead( DXAStream->DecodeTempBuffer, FileH->PressDataSize, 1, DXAStream->WinFilePointer ) ;
					DXAStream->ASyncState = DXARC_STREAM_ASYNCSTATE_PRESSREAD ;
				}
				else
				{
					if( DXA->HeadV5.Version >= 0x0005 )
					{
						DXA_KeyConvFileRead( DXAStream->DecodeTempBuffer, FileH->PressDataSize, DXAStream->WinFilePointer, DXA->Key, FileH->DataSize ) ;
					}
					else
					{
						DXA_KeyConvFileRead( DXAStream->DecodeTempBuffer, FileH->PressDataSize, DXAStream->WinFilePointer, DXA->Key ) ;
					}

					// 
					DXA_Decode( DXAStream->DecodeTempBuffer, DXAStream->DecodeDataBuffer ) ;
				
					// ̉
					DXFREE( DXAStream->DecodeTempBuffer ) ;
					DXAStream->DecodeTempBuffer = NULL ;
				}
			}
		}
	}
	else
	{
		DXARC_FILEHEAD *FileH ;

		// w̃t@C̏𓾂
		FileH = DXA_GetFileInfo( DXA, FilePath ) ;
		if( FileH == NULL )
		{
			ReadOnlyFileAccessClose( DXAStream->WinFilePointer ) ;
			DXAStream->WinFilePointer = 0 ;
			return -1 ;
		}

		// t@CZbg
		DXAStream->FileHead = FileH ;

		// t@CkĂꍇ͂œǂݍŉ𓀂Ă܂
		if( FileH->PressDataSize != NONE_PAL )
		{
			// 𓀃f[^܂郁̈̊m
			DXAStream->DecodeDataBuffer = DXALLOC( ( size_t )FileH->DataSize ) ;

			// ɓǂݍ܂Ă邩ǂŏ𕪊
			if( DXA->MemoryOpenFlag == TRUE )
			{
				// 
				DXA_Decode( (BYTE *)DXA->MemoryImage + DXA->Head.DataStartAddress + FileH->DataAddress, DXAStream->DecodeDataBuffer ) ;
			}
			else
			{
				// kf[^܂郁̈̊m
				DXAStream->DecodeTempBuffer = DXALLOC( ( size_t )FileH->PressDataSize ) ;

				// kf[^̓ǂݍ
				DXAStream->ASyncReadFileAddress = DXA->Head.DataStartAddress + FileH->DataAddress;
				ReadOnlyFileAccessSeek( DXAStream->WinFilePointer, DXAStream->ASyncReadFileAddress, SEEK_SET ) ;

				// 񓯊̏ꍇ͓ǂݍ݂ƌʁXɍs
				if( DXAStream->UseASyncReadFlag == TRUE )
				{
					// t@Cǂݍ
					ReadOnlyFileAccessRead( DXAStream->DecodeTempBuffer, ( size_t )FileH->PressDataSize, 1, DXAStream->WinFilePointer ) ;
					DXAStream->ASyncState = DXARC_STREAM_ASYNCSTATE_PRESSREAD ;
				}
				else
				{
					DXA_KeyConvFileRead( DXAStream->DecodeTempBuffer, FileH->PressDataSize, DXAStream->WinFilePointer, DXA->Key, FileH->DataSize ) ;

					// 
					DXA_Decode( DXAStream->DecodeTempBuffer, DXAStream->DecodeDataBuffer ) ;
				
					// ̉
					DXFREE( DXAStream->DecodeTempBuffer ) ;
					DXAStream->DecodeTempBuffer = NULL ;
				}
			}
		}
	}

	// I
	return 0 ;
}

// A[JCut@C̃t@C
extern int DXA_STREAM_Terminate( DXARC_STREAM *DXAStream )
{
	// 񓯊ǂݍ݂ŏԂ܂ҋ@Ԃł͂Ȃҋ@ԂɂȂ܂ő҂
	if( DXAStream->UseASyncReadFlag == TRUE && DXAStream->ASyncState != DXARC_STREAM_ASYNCSTATE_IDLE )
	{
		while( DXA_STREAM_IdleCheck( DXAStream ) == FALSE ) Sleep(1);
	}

	// ̉
	if( DXAStream->DecodeDataBuffer != NULL )
	{
		DXFREE( DXAStream->DecodeDataBuffer ) ;
		DXAStream->DecodeDataBuffer = NULL ;
	}

	if( DXAStream->DecodeTempBuffer != NULL )
	{
		DXFREE( DXAStream->DecodeTempBuffer ) ;
		DXAStream->DecodeTempBuffer = NULL ;
	}

	// t@C
	ReadOnlyFileAccessClose( DXAStream->WinFilePointer ) ;
	DXAStream->WinFilePointer = 0 ;

	// [
	_MEMSET( DXAStream, 0, sizeof( DXARC_STREAM ) ) ;

	// I
	return 0 ;
}

// t@C̓eǂݍ
extern int DXA_STREAM_Read( DXARC_STREAM *DXAStream, void *Buffer, size_t ReadLength )
{
	size_t ReadSize ;
	ULONGLONG DataSize ;
	ULONGLONG DataStartAddress ;
	ULONGLONG DataAddress ;

	// 񓯊ǂݍ݂ŏԂ܂ҋ@Ԃł͂Ȃҋ@ԂɂȂ܂ő҂
	if( DXAStream->UseASyncReadFlag == TRUE && DXAStream->ASyncState != DXARC_STREAM_ASYNCSTATE_IDLE )
	{
		while( DXA_STREAM_IdleCheck( DXAStream ) == FALSE ) Sleep(1);
	}

	if( DXAStream->Archive->V5Flag )
	{
		DataSize = DXAStream->FileHeadV5->DataSize ;
		DataAddress = DXAStream->FileHeadV5->DataAddress ;
		DataStartAddress = DXAStream->Archive->HeadV5.DataStartAddress ;
	}
	else
	{
		DataSize = DXAStream->FileHead->DataSize ;
		DataAddress = DXAStream->FileHead->DataAddress ;
		DataStartAddress = DXAStream->Archive->Head.DataStartAddress ;
	}

	// EOF tOĂOԂ
	if( DXAStream->EOFFlag == TRUE ) return 0 ;

	// EOF o
	if( DataSize == DXAStream->FilePoint )
	{
		DXAStream->EOFFlag = TRUE ;
		return 0 ;
	}

	// f[^ǂݍޗʂݒ肷
	ReadSize = ReadLength < DataSize - DXAStream->FilePoint ? ReadLength : ( size_t )( DataSize - DXAStream->FilePoint ) ;

	// f[^kĂǂŏ𕪊
	if( DXAStream->DecodeDataBuffer != NULL )
	{
		// f[^Rs[
		_MEMCPY( Buffer, (BYTE *)DXAStream->DecodeDataBuffer + DXAStream->FilePoint, ReadSize ) ;
	}
	else
	{
		// Ƀf[^邩ǂŏ𕪊
		if( DXAStream->Archive->MemoryOpenFlag == TRUE )
		{
			// ɂꍇ

			// f[^Rs[
			_MEMCPY( Buffer, (BYTE *)DXAStream->Archive->MemoryImage + DataStartAddress + DataAddress + DXAStream->FilePoint, ReadSize ) ;
		}
		else
		{
			// t@Cǂݍłꍇ

			// A[JCut@C|C^ƁAzt@C|C^vĂ邩ׂ
			// vĂȂA[JCut@C|C^ړ
			DXAStream->ASyncReadFileAddress = DataAddress + DataStartAddress + DXAStream->FilePoint ;
			if( ( ULONGLONG )ReadOnlyFileAccessTell( DXAStream->WinFilePointer ) != DXAStream->ASyncReadFileAddress )
			{
				ReadOnlyFileAccessSeek( DXAStream->WinFilePointer, DXAStream->ASyncReadFileAddress, SEEK_SET ) ;
			}

			// 񓯊ǂݍ݂̏ꍇƓǂݍ݂̏ꍇŏ𕪊
			if( DXAStream->UseASyncReadFlag )
			{
				// t@Cǂݍ
				ReadOnlyFileAccessRead( Buffer, ReadSize, 1, DXAStream->WinFilePointer ) ;
				DXAStream->ReadBuffer = Buffer;
				DXAStream->ReadSize = ( int )ReadSize;
				DXAStream->ASyncState = DXARC_STREAM_ASYNCSTATE_READ ;
			}
			else
			{
				// f[^ǂݍ
				if( DXAStream->Archive->V5Flag )
				{
					if( DXAStream->Archive->HeadV5.Version >= 0x0005 )
					{
						DXA_KeyConvFileRead( Buffer, ( int )ReadSize, DXAStream->WinFilePointer, DXAStream->Archive->Key, DataSize + DXAStream->FilePoint ) ;
					}
					else
					{
						DXA_KeyConvFileRead( Buffer, ( int )ReadSize, DXAStream->WinFilePointer, DXAStream->Archive->Key ) ;
					}
				}
				else
				{
					DXA_KeyConvFileRead( Buffer, ( int )ReadSize, DXAStream->WinFilePointer, DXAStream->Archive->Key, DataSize + DXAStream->FilePoint ) ;
				}
			}
		}
	}
	
	// EOF tO|
	DXAStream->EOFFlag = FALSE ;

	// ǂݍ񂾕t@C|C^ړ
	DXAStream->FilePoint += ( int )ReadSize ;
	
	// ǂݍ񂾗eʂԂ
	return ( int )ReadSize ;
}
	
// t@C|C^ύX
extern	int DXA_STREAM_Seek( DXARC_STREAM *DXAStream, LONGLONG SeekPoint, int SeekMode )
{
	ULONGLONG DataSize ;

	// 񓯊ǂݍ݂ŏԂ܂ҋ@Ԃł͂Ȃҋ@ԂɂȂ܂ő҂
	if( DXAStream->UseASyncReadFlag == TRUE && DXAStream->ASyncState != DXARC_STREAM_ASYNCSTATE_IDLE )
	{
		while( DXA_STREAM_IdleCheck( DXAStream ) == FALSE ) Sleep(1);
	}

	if( DXAStream->Archive->V5Flag )
	{
		DataSize = DXAStream->FileHeadV5->DataSize ;
	}
	else
	{
		DataSize = DXAStream->FileHead->DataSize ;
	}

	// V[N^Cvɂď𕪊
	switch( SeekMode )
	{
	case SEEK_SET : break ;		
	case SEEK_CUR : SeekPoint += ( LONGLONG )( DXAStream->FilePoint ) ; break ;
	case SEEK_END :	SeekPoint  = ( LONGLONG )( DataSize + SeekPoint ) ; break ;
	}
	
	// ␳
	if( SeekPoint > ( LONGLONG )DataSize ) SeekPoint = ( LONGLONG )DataSize ;
	if( SeekPoint < 0 ) SeekPoint = 0 ;
	
	// Zbg
	DXAStream->FilePoint = SeekPoint ;
	
	// EOFtO|
	DXAStream->EOFFlag = FALSE ;
	
	// I
	return 0 ;
}

// ݂̃t@C|C^𓾂
extern	LONGLONG DXA_STREAM_Tell( DXARC_STREAM *DXAStream )
{
	// 񓯊ǂݍ݂ŏԂ܂ҋ@Ԃł͂Ȃҋ@ԂɂȂ܂ő҂
	if( DXAStream->UseASyncReadFlag == TRUE && DXAStream->ASyncState != DXARC_STREAM_ASYNCSTATE_IDLE )
	{
		while( DXA_STREAM_IdleCheck( DXAStream ) == FALSE ) Sleep(1);
	}

	return ( LONGLONG )DXAStream->FilePoint ;
}

// t@C̏I[ɗĂ邩ÃtO𓾂
extern	int DXA_STREAM_Eof( DXARC_STREAM *DXAStream )
{
	// 񓯊ǂݍ݂ŏԂ܂ҋ@Ԃł͂Ȃҋ@ԂɂȂ܂ő҂
	if( DXAStream->UseASyncReadFlag == TRUE && DXAStream->ASyncState != DXARC_STREAM_ASYNCSTATE_IDLE )
	{
		while( DXA_STREAM_IdleCheck( DXAStream ) == FALSE ) Sleep(1);
	}

	return DXAStream->EOFFlag ? EOF : 0 ;
}

// ǂݍݏĂ邩ǂ𒲂ׂ
extern	int	DXA_STREAM_IdleCheck( DXARC_STREAM *DXAStream )
{
	// 񓯊ǂݍ݂ł͂Ȃꍇ͉ TRUE Ԃ
	if( DXAStream->UseASyncReadFlag == FALSE ) return TRUE ;

	// Ԃɂď𕪊
	switch( DXAStream->ASyncState )
	{
	case DXARC_STREAM_ASYNCSTATE_IDLE:			// ҋ@
		return TRUE;

	case DXARC_STREAM_ASYNCSTATE_PRESSREAD:		// kf[^ǂݍݑ҂

		// ǂݍݏI҂
		if( ReadOnlyFileAccessIdleCheck( DXAStream->WinFilePointer ) == FALSE ) return FALSE;

		// ǂݍݏI܂O
		if( DXAStream->Archive->V5Flag )
		{
			if( DXAStream->Archive->HeadV5.Version >= 0x0005 )
			{
				DXA_KeyConv( DXAStream->DecodeTempBuffer, DXAStream->FileHeadV5->PressDataSize, DXAStream->FileHeadV5->DataSize, DXAStream->Archive->Key ) ;
			}
			else
			{
				DXA_KeyConv( DXAStream->DecodeTempBuffer, DXAStream->FileHeadV5->PressDataSize, DXAStream->ASyncReadFileAddress, DXAStream->Archive->Key ) ;
			}
		}
		else
		{
			DXA_KeyConv( DXAStream->DecodeTempBuffer, DXAStream->FileHead->PressDataSize, DXAStream->FileHead->DataSize, DXAStream->Archive->Key ) ;
		}

		// 
		DXA_Decode( DXAStream->DecodeTempBuffer, DXAStream->DecodeDataBuffer ) ;
	
		// ̉
		DXFREE( DXAStream->DecodeTempBuffer ) ;
		DXAStream->DecodeTempBuffer = NULL ;

		// Ԃҋ@Ԃɂ
		DXAStream->ASyncState = DXARC_STREAM_ASYNCSTATE_IDLE;
		return TRUE;

	case DXARC_STREAM_ASYNCSTATE_READ:			// ǂݍݑ҂

		// ǂݍݏI҂
		if( ReadOnlyFileAccessIdleCheck( DXAStream->WinFilePointer ) == FALSE ) return FALSE;

		// ǂݍݏI献O
		if( DXAStream->Archive->V5Flag )
		{
			if( DXAStream->Archive->HeadV5.Version >= 0x0005 )
			{
				DXA_KeyConv( DXAStream->ReadBuffer, DXAStream->ReadSize, DXAStream->FileHeadV5->DataSize + ( DXAStream->ASyncReadFileAddress - ( DXAStream->FileHeadV5->DataAddress + DXAStream->Archive->HeadV5.DataStartAddress ) ), DXAStream->Archive->Key ) ;
			}
			else
			{
				DXA_KeyConv( DXAStream->ReadBuffer, DXAStream->ReadSize, DXAStream->ASyncReadFileAddress, DXAStream->Archive->Key ) ;
			}
		}
		else
		{
			DXA_KeyConv( DXAStream->ReadBuffer, DXAStream->ReadSize, DXAStream->FileHead->DataSize + ( DXAStream->ASyncReadFileAddress - ( DXAStream->FileHead->DataAddress + DXAStream->Archive->Head.DataStartAddress ) ), DXAStream->Archive->Key ) ;
		}

		// Ԃҋ@Ԃɂ
		DXAStream->ASyncState = DXARC_STREAM_ASYNCSTATE_IDLE;
		return TRUE;
	}

	return TRUE ;
}

// t@C̃TCY擾
extern	LONGLONG DXA_STREAM_Size( DXARC_STREAM *DXAStream )
{
	if( DXAStream->Archive->V5Flag )
	{
		return DXAStream->FileHeadV5->DataSize ;
	}
	else
	{
		return ( LONGLONG )DXAStream->FileHead->DataSize ;
	}
}







// tpXł͂ȂpXtpXɕϊ
static int DXA_DIR_ConvertFullPath( const TCHAR *Src, TCHAR *Dest )
{
	int i, j, k ;
	TCHAR iden[256], CurrentDir[MAX_PATH] ;

	// JgfBNg𓾂
	GetCurrentDirectory( MAX_PATH, CurrentDir ) ;
	_TSTRUPR( CurrentDir ) ;

	if( Src == NULL )
	{
		lstrcpy( Dest, CurrentDir ) ;
		goto END ;
	}

	i = 0 ;
	j = 0 ;
	k = 0 ;

	// ŏɁw\x́w/xQAőĂꍇ̓lbg[NĂƔf
	if( ( Src[0] == _T( '\\' ) && Src[1] == _T( '\\' ) ) ||
		( Src[0] == _T( '/' )  && Src[1] == _T( '/'  ) ) )
	{
		Dest[0] = _T( '\\' ) ;
		Dest[1] = _T( '\0' ) ;

		i += 2;
		j ++ ;
	}
	else
	// ŏw\x́w/x̏ꍇ̓JghCũ[gfBNg܂ŗ
	if( Src[0] == _T( '\\' ) || Src[0] == _T( '/' ) )
	{
		Dest[0] = CurrentDir[0] ;
		Dest[1] = CurrentDir[1] ;
		Dest[2] = _T( '\0' ) ;

		i ++ ;
		j = 2 ;
	}
	else
	// hCuĂ炻̃hCu
	if( Src[1] == _T( ':' ) )
	{
		Dest[0] = CHARUP(Src[0]) ;
		Dest[1] = Src[1] ;
		Dest[2] = _T( '\0' ) ;

		i = 2 ;
		j = 2 ;

		if( Src[i] == _T( '\\' ) ) i ++ ;
	}
	else
	// ȊȌꍇ̓JgfBNg
	{
		lstrcpy( Dest, CurrentDir ) ;
		j = lstrlen( Dest ) ;
		if( Dest[j-1] == _T( '\\' ) || Dest[j-1] == _T( '/' ) )
		{
			Dest[j-1] = _T( '\0' ) ;
			j -- ;
		}
	}

	for(;;)
	{
		switch( Src[i] )
		{
		case _T( '\0' ) :
			if( k != 0 )
			{
				Dest[j] = _T( '\\' ) ; j ++ ;
				lstrcpy( &Dest[j], iden ) ;
				j += k ;
				k = 0 ;
			}
			goto END ;

		case _T( '\\' ) :
		case _T( '/' ) :
			// 񂪖XLbv
			if( k == 0 )
			{
				i ++ ;
				break;
			}
			if( lstrcmp( iden, _T( "." ) ) == 0 )
			{
				// ȂɂȂ
			}
			else
			if( lstrcmp( iden, _T( ".." ) ) == 0 )
			{
				// ̃fBNg
				j -- ;
//				while( Dest[j] != _T( '\\' ) && Dest[j] != _T( '/' ) && Dest[j] != _T( ':' ) ) j -- ;
				for(;;)
				{
					if( Dest[j] == _T( '\\' ) || Dest[j] == _T( '/' ) || Dest[j] == _T( ':' ) ) break ;
					j -= CheckDoubleChar( Dest, j - 1, _GET_CHARSET() ) == 2 ? 2 : 1 ;
				}
				if( Dest[j] != _T( ':' ) ) Dest[j] = _T( '\0' ) ;
				else j ++ ;
			}
			else
			{
				Dest[j] = _T( '\\' ) ; j ++ ;
				lstrcpy( &Dest[j], iden ) ;
				j += k ;
			}

			k = 0 ;
			i ++ ;
			break ;
		
		default :
			if( _TMULT( Src[i], _GET_CHARSET() ) == FALSE  )
			{
				iden[k] = CHARUP(Src[i]) ;
				iden[k+1] = _T( '\0' ) ; 
				k ++ ;
				i ++ ;
			}
			else
			{
				iden[k]   = Src[i] ;
				iden[k+1] = Src[i+1] ;
				iden[k+2] = _T( '\0' ) ;
				k += 2 ;
				i += 2 ;
			}
			break ;
		}
	}
	
END :
	// I
	return 0 ;
}

// t@CꏏɂȂĂƕĂpXt@CƃfBNgpX𕪊
// tpXłKv͖At@Cłǂ
// DirPath ̏I[  }[N͕tȂ
static int DXA_DIR_AnalysisFileNameAndDirPath( DXARC *DXA, const char *Src, char *FileName, char *DirPath )
{
	int i, Last ;
	
	// t@C𔲂o
	i = 0 ;
	Last = -1 ;
	while( Src[i] != '\0' )
	{
		if( CheckMultiByteChar( Src[i], DXA->CharSet ) == FALSE )
		{
			if( Src[i] == '\\' || Src[i] == '/' || Src[i] == '\0' || Src[i] == ':' ) Last = i ;
			i ++ ;
		}
		else
		{
			i += 2 ;
		}
	}
	if( FileName != NULL )
	{
		if( Last != -1 ) _STRCPY( FileName, &Src[Last+1] ) ;
		else             _STRCPY( FileName, Src ) ;
	}
	
	// fBNgpX𔲂o
	if( DirPath != NULL )
	{
		if( Last != -1 )
		{
			_MEMCPY( DirPath, Src, Last ) ;
			DirPath[Last] = '\0' ;
		}
		else
		{
			DirPath[0] = '\0' ;
		}
	}
	
	// I
	return 0 ;
}

// CmpStr ̏ Src K邩ǂ𒲂ׂ( 0:K  -1:KȂ )
static int DXA_DIR_FileNameCmp( DXARC *DXA, const char *Src, const char *CmpStr )
{
	const char *s, *c;

	s = Src;
	c = CmpStr;
	while( *c != '\0' || *s != '\0' )
	{
		if( CheckMultiByteChar( *c, DXA->CharSet ) == TRUE )
		{
			if( *((WORD *)s) != *((WORD *)c) ) return -1;
			c += 2;
			s += 2;
		}
		else
		{
			switch( *c )
			{
			case '?':
				c ++ ;
				s ++ ;
				break;

			case '*':
				while( *c == '*' ) c ++ ;
				if( *c == '\0' ) return 0;
				while( *s != '\0' && *s != *c ) s ++ ;
				if( *s == '\0' ) return -1;
				c ++ ;
				s ++ ;
				break;

			default:
				if( *c != *s ) return -1;
				c ++ ;
				s ++ ;
				break;
			}
		}
		if( ( *c == '\0' && *s != '\0' ) || ( *c != '\0' && *s == '\0' ) ) return -1;
	}

	return 0;
}

// A[JCut@CtH_ɌĂăt@CJ̏𓾂( -1:A[JCuƂĂ݂͑Ȃ  0:݂ )
static int DXA_DIR_OpenTest( const TCHAR *FilePath, int *ArchiveIndex, char *ArchivePath, char *ArchiveFilePath )
{
	int i, len, arcindex ;
	TCHAR fullpath[256], path[256], temp[256], dir[256], *p ;

	// tpX𓾂(łɑSĂ̕啶ɂ)
	DXA_DIR_ConvertFullPath( FilePath, fullpath ) ;

	// OƎgpA[JCũpXꍇ͓A[JCugp
	if( DXARCD.BackUseDirectoryPathLength != 0 && _TSTRNCMP( fullpath, DXARCD.BackUseDirectory, DXARCD.BackUseDirectoryPathLength ) == 0 &&
		( fullpath[ DXARCD.BackUseDirectoryPathLength ] == _T( '\\' ) || fullpath[ DXARCD.BackUseDirectoryPathLength ] == _T( '/' ) ) )
	{
		// Ogpcw`t@CJ
		arcindex = DXA_DIR_OpenArchive( DXARCD.BackUseDirectory, DXARCD.BackUseArchiveIndex ) ;
		if( arcindex == -1 ) return -1 ;

		// cw`t@Cꏊȍ~̃pX쐬
		p = &fullpath[ DXARCD.BackUseDirectoryPathLength + 1 ] ;
	}
	else
	{
		// OƂ͈ႤpX̏ꍇ͈ꂩ璲ׂ

		// fBNgǂčs
		p = fullpath ;
		len = 0 ;
		for(;;)
		{
			// lbg[NĂꍇ̐p
			if( p - fullpath == 0 && fullpath[0] == _T( '\\' ) && fullpath[1] == _T( '\\' ) )
			{
				path[0] = _T( '\\' );
				path[1] = _T( '\\' );
				path[2] = _T( '\0' );
				len += 2;
				p += 2;
			}

			// fBNg
			for( i = 0 ; *p != _T( '\0' ) && *p !=  _T( '/' ) && *p != _T( '\\' ) ; )
			{
				if( _TMULT( *p, _GET_CHARSET() ) )
				{
					dir[i  ] = path[len+i  ] = p[ 0 ] ;
					dir[i+1] = path[len+i+1] = p[ 1 ] ;
					i += 2 ;
					p += 2 ;
				}
				else
				{
					dir[i] = path[len+i] = *p ;
					i ++ ;
					p ++ ;
				}
			}
			if( *p == _T( '\0' ) || i == 0 ) return -1;
			p ++ ;
			dir[i] = path[len+i] = _T( '\0' ) ;
			len += i ;

			// tH_DXA[JCut@Cɂ
			_MEMCPY( temp, path, len * 2 ) ;
			temp[len] = _T( '.' ) ;
			if( DXARCD.ArchiveExtensionLength == 0 )	_MEMCPY( &temp[len+1], _T( "DXA" ), 4 * sizeof( TCHAR ) ) ;
			else										_MEMCPY( &temp[len+1], DXARCD.ArchiveExtension, ( DXARCD.ArchiveExtensionLength + 1 ) * sizeof( TCHAR ) ) ;

			// cw`t@CƂĊJĂ݂
			arcindex = DXA_DIR_OpenArchive( temp ) ;
			if( arcindex != -1 ) break ;

			// JȂ玟̊Kw
			path[len] = _T( '\\' ) ;
			len ++ ;
		}

		// J獡̏ۑ
		if( DXARCD.ArchiveExtensionLength == 0 )
			_MEMCPY( DXARCD.BackUseDirectory, temp, ( len + 3 + 2 ) * sizeof( TCHAR ) ) ;
		else
			_MEMCPY( DXARCD.BackUseDirectory, temp, ( len + DXARCD.ArchiveExtensionLength + 2 ) * sizeof( TCHAR ) ) ;
		DXARCD.BackUseDirectoryPathLength = len ;
		DXARCD.BackUseArchiveIndex        = arcindex ;
	}

	// Zbg
	*ArchiveIndex = arcindex;
#ifdef UNICODE
	int CodePage ;
	CodePage = DXARCD.Archive[ arcindex ]->Archive.HeadV5.CodePage ;
	if( CodePage == 0 ) CodePage = _GET_CODEPAGE() ;
	if( ArchivePath )		WCharToMBChar( CodePage, ( DXWCHAR * )DXARCD.BackUseDirectory, ArchivePath,     512 ) ;
	if( ArchiveFilePath )	WCharToMBChar( CodePage, ( DXWCHAR * )p,                       ArchiveFilePath, 512 ) ;
#else
	if( ArchivePath     ) lstrcpy( ArchivePath,     DXARCD.BackUseDirectory );
	if( ArchiveFilePath ) lstrcpy( ArchiveFilePath, p                       );
#endif

	// I
	return 0;
}

// A[JCut@CJ
static int DXA_DIR_OpenArchive( const TCHAR *FilePath, int ArchiveIndex, int OnMemory, int ASyncThread )
{
	int i, index, newindex ;
	DXARC_DIR_ARCHIVE *arc, *tarc ;
	DXARC temparc ;

	// A[JCu̎w肪ꍇ͂̂܂܎gp
	if( ArchiveIndex != -1 )
	{
		tarc = DXARCD.Archive[ ArchiveIndex ] ;
		if( tarc != NULL )
		{
			if(	lstrcmp( FilePath, tarc->Path ) == 0 )
			{
				DXARCD.Archive[ArchiveIndex]->UseCounter ++ ;
				return ArchiveIndex ;
			}
		}
	}

	// ɊJĂ邩ׂ
	newindex = -1 ;
	index    = 0 ;
	for( i = 0 ; i < DXARCD.ArchiveNum ; index ++ )
	{
		arc = DXARCD.Archive[index] ;
		if( arc == NULL )
		{
			newindex = index ;
			continue ;
		}
		
		i ++ ;

		if( lstrcmp( arc->Path, FilePath ) == 0 )
		{
			// ɊJĂꍇ͂̃CfbNXԂ
			arc->UseCounter ++ ;
			return index ;
		}
	}
	
	// Ȃꍇ͐VKɃf[^ǉ

	// nhɈt̏ꍇ͎gpĂȂA[JCunh
	if( DXARCD.ArchiveNum == DXA_DIR_MAXARCHIVENUM )
	{
		// gp̃nh
		DXA_DIR_CloseWaitArchive() ;
		
		// łtłꍇ̓G[
		if( DXARCD.ArchiveNum == DXA_DIR_MAXARCHIVENUM )
			return -1 ;
	} 
	if( newindex == -1 )
	{
		for( newindex = 0 ; DXARCD.Archive[newindex] != NULL ; newindex ++ ){}
	}

	// A[JCut@C݂Ă邩mFĂ珉
	DXA_Initialize( &temparc ) ;
	if( OnMemory == TRUE )
	{
		// ɓǂݍޏꍇ
		if( DXA_OpenArchiveFromFileUseMem( &temparc, FilePath, DXARCD.ValidKeyString == TRUE ? DXARCD.KeyString : NULL, ASyncThread ) < 0 )
			return -1 ;
	}
	else
	{
		// t@Cǂݍޏꍇ
		if( DXA_OpenArchiveFromFile( &temparc, FilePath, DXARCD.ValidKeyString == TRUE ? DXARCD.KeyString : NULL ) < 0 )
			return -1 ;
	}

	// VA[JCuf[^p̃mۂ
	arc = DXARCD.Archive[newindex] = (DXARC_DIR_ARCHIVE *)DXALLOC( sizeof( DXARC_DIR_ARCHIVE ) ) ;
	if( DXARCD.Archive[newindex] == NULL )
	{
		DXA_CloseArchive( &temparc ) ;
		DXA_Terminate( &temparc ) ;
		return -1 ;
	}

	// Zbg
	_MEMCPY( &arc->Archive, &temparc, sizeof( DXARC ) ) ;
	arc->UseCounter = 1 ;
	lstrcpy( arc->Path, FilePath ) ;

	// gp̃A[JCu̐𑝂₷
	DXARCD.ArchiveNum ++ ;

	// CfbNXԂ
	return newindex ;
}

// ɊJĂA[JCũnh擾( ߂l: -1= 0ȏ:nh )
static int DXA_DIR_GetArchive( const TCHAR *FilePath )
{
	int i, index ;
	DXARC_DIR_ARCHIVE *arc ;

	index = 0 ;
	for( i = 0 ; i < DXARCD.ArchiveNum ; index ++ )
	{
		arc = DXARCD.Archive[index] ;
		if( arc == NULL ) continue ;

		i ++ ;

		if( lstrcmp( arc->Path, FilePath ) == 0 )
			return index ;
	}

	return -1 ;
}

// A[JCut@C
static int DXA_DIR_CloseArchive( int ArchiveHandle )
{
	DXARC_DIR_ARCHIVE *arc ;

	// gpĂȂ牽I
	arc = DXARCD.Archive[ArchiveHandle] ;
	if( arc == NULL || arc->UseCounter == 0 ) return -1 ;

	// QƃJE^炷
	arc->UseCounter -- ;

	// I
	return 0 ;
}

// gp̂҂ĂA[JCut@CSĕ
static void DXA_DIR_CloseWaitArchive( void )
{
	int i, Num, index ;
	DXARC_DIR_ARCHIVE *arc ;
	
	Num = DXARCD.ArchiveNum ;
	for( i = 0, index = 0 ; i < Num ; index ++ )
	{
		if( DXARCD.Archive[index] == NULL ) continue ;
		i ++ ;

		arc = DXARCD.Archive[index] ;

		// gĂȂ
		if( arc->UseCounter > 0 ) continue ;

		// n
		DXA_CloseArchive( &arc->Archive ) ;
		DXA_Terminate( &arc->Archive ) ;
		DXFREE( arc ) ;
		DXARCD.Archive[index] = NULL ;
		
		// A[JCu̐炷
		DXARCD.ArchiveNum -- ;
	}
}

// A[JCufBNgɌĂ鏈̏
extern	int DXA_DIR_Initialize( void )
{
	// ɏς݂̏ꍇ͉Ȃ
	if( DXARCD.InitializeFlag )
		return -1 ;

	// NeBJZNV̏
	CriticalSection_Initialize( &DXARCD.CriticalSection ) ;

//	_MEMSET( &DXARCD, 0, sizeof( DXARC_DIR ) ) ;
//	DXA_DIR_Terminate() ;

	// gpĂȂA[JCut@C
	DXA_DIR_CloseWaitArchive() ;

	// tO𗧂Ă
	DXARCD.InitializeFlag = TRUE ;

	// I
	return 0 ;
}


// A[JCufBNgɌĂ鏈̌n
extern int DXA_DIR_Terminate( void )
{
	// Ɍnς݂̏ꍇ͉Ȃ
	if( DXARCD.InitializeFlag == FALSE )
		return -1 ;

	// gpĂȂA[JCut@C
	DXA_DIR_CloseWaitArchive() ;

	// NeBJZNV̌n
	CriticalSection_Delete( &DXARCD.CriticalSection ) ;

	// tO|
	DXARCD.InitializeFlag = FALSE ;

	// I
	return 0 ;
}

// A[JCut@C̊gqݒ肷
extern int DXA_DIR_SetArchiveExtension( const TCHAR *Extension )
{
	int Length ;
	
	Length = lstrlen( Extension ) ;

	if( Length >= 64 || Extension == NULL || Extension[0] == _T( '\0' ) )
	{
		DXARCD.ArchiveExtension[0] = 0 ;
		DXARCD.ArchiveExtensionLength = 0 ;
	}
	else
	{
		DXARCD.ArchiveExtensionLength = Length ;
		lstrcpy( DXARCD.ArchiveExtension, Extension ) ;
	}

	// I
	return 0 ;
}

// A[JCut@Cƒʏ̃tH_̂ǂ݂ꍇAǂD悳邩ݒ肷( 1:tH_D 0:cwA[JCut@CD(ftHg) )
extern int DXA_DIR_SetDXArchivePriority( int Priority )
{
	DXARCD.DXAPriority = Priority ;

	// I
	return 0 ;
}

// A[JCut@Čݒ肷
extern int DXA_DIR_SetKeyString( const char *KeyString )
{
	if( KeyString == NULL )
	{
		DXARCD.ValidKeyString = FALSE ;
	}
	else
	{
		DXARCD.ValidKeyString = TRUE ;
		if( lstrlenA( KeyString ) > DXA_KEYSTR_LENGTH )
		{
			_MEMCPY( DXARCD.KeyString, KeyString, DXA_KEYSTR_LENGTH ) ;
			DXARCD.KeyString[ DXA_KEYSTR_LENGTH ] = '\0' ;
		}
		else
		{
			_STRCPY( DXARCD.KeyString, KeyString ) ;
		}
	}

	// I
	return 0 ;
}

// t@CۂƓǂݍފ֐
extern LONGLONG DXA_DIR_LoadFile( const TCHAR *FilePath, void *Buffer, int BufferSize )
{
	LONGLONG siz ;
	DWORD_PTR handle ;

	handle = DXA_DIR_Open( FilePath ) ;
	if( handle == -1 ) return false ;

	DXA_DIR_Seek( handle, 0L, SEEK_END ) ;
	siz = DXA_DIR_Tell( handle ) ;
	DXA_DIR_Seek( handle, 0L, SEEK_SET ) ;

	if( siz <= BufferSize )
	{
		DXA_DIR_Read( Buffer, ( size_t )siz, 1, handle ) ;
	}

	DXA_DIR_Close( handle ) ;

	// I
	return siz ;
}

// DXA_DIR_Open ̊{֐
extern DWORD_PTR DXA_DIR_Open( const TCHAR *FilePath, int UseCacheFlag, int BlockReadFlag, int UseASyncReadFlag )
{
	int index ;
	DXARC_DIR_FILE *file ;
	char DXAErrorStr[256], DxaInFilePath[256] ;

	// ĂȂ珉
	if( DXARCD.InitializeFlag == FALSE )
	{
		DXA_DIR_Initialize() ;
	}

	// NeBJZNV̎擾
	CRITICALSECTION_LOCK( &DXARCD.CriticalSection ) ;

	UseCacheFlag  = UseCacheFlag ;
	BlockReadFlag = BlockReadFlag ;
	DXAErrorStr[0] = 0 ;

	// 󂫃f[^T
	if( DXARCD.FileNum == DXA_DIR_MAXFILENUM )
	{
		// NeBJZNV̉
		CriticalSection_Unlock( &DXARCD.CriticalSection ) ;

		DXST_ERRORLOG_ADD( _T( "ɊJt@C̐E𒴂܂\n" ) ) ;
		return 0 ;
	}
	for( index = 0 ; DXARCD.File[index] != NULL ; index ++ ){}

	// ̊m
	DXARCD.File[index] = (DXARC_DIR_FILE *)DXALLOC( sizeof( DXARC_DIR_FILE ) ) ;
	if( DXARCD.File[index] == NULL )
	{
		// NeBJZNV̉
		CriticalSection_Unlock( &DXARCD.CriticalSection ) ;

		DXST_ERRORLOG_ADD( _T( "t@C̏i[郁̊mۂɎs܂\n" ) ) ;
		return 0 ;
	}
	file = DXARCD.File[index] ;

	// A[JCut@CƃtH_̂ǂD悷邩ŏ𕪊
	if( DXARCD.DXAPriority == 0 )
	{
		// A[JCuD悷ꍇ

		// A[JCut@Cׂ
		if( DXA_DIR_OpenTest( FilePath, (int *)&file->UseArchiveIndex, NULL, DxaInFilePath ) == 0 )
		{
			// A[JCugpĂtO𗧂Ă
			file->UseArchiveFlag = 1 ;

			// fBNgƓ̂cw`t@CJ炻̒w̃t@CǂݍƂ
			if( DXA_STREAM_Initialize( &file->DXAStream, &DXARCD.Archive[ file->UseArchiveIndex ]->Archive, DxaInFilePath, UseASyncReadFlag ) < 0 )
			{
				_STRCPY( DXAErrorStr, DXSTRING( "cw`t@C̒Ɏw̃t@C͌܂ł\n" ) ) ;
				DXA_DIR_CloseArchive( file->UseArchiveIndex ) ;
				goto ERR ;
			}
		}
		else
		{
			// A[JCut@C畁ʂ̃t@Cǂݍސݒs
			file->UseArchiveFlag = 0 ;

			// ʂ̃t@Cׂ
			file->WinFilePointer_ = ReadOnlyFileAccessOpen( FilePath, UseCacheFlag, TRUE, UseASyncReadFlag ) ;
			if( file->WinFilePointer_ == 0 ) goto ERR ;
		}
	}
	else
	{
		// ʂ̃t@CD悷ꍇ

		// ʂ̃t@Cׂ
		if( ( file->WinFilePointer_ = ReadOnlyFileAccessOpen( FilePath, UseCacheFlag, TRUE, UseASyncReadFlag ) ) != 0 )
		{
			// J畁ʂ̃t@Cǂݍސݒs
			file->UseArchiveFlag = 0 ;
		}
		else
		{
			// A[JCut@Cׂ
			if( DXA_DIR_OpenTest( FilePath, (int *)&file->UseArchiveIndex, NULL, DxaInFilePath ) == 0 )
			{
				// A[JCugpĂtO𗧂Ă
				file->UseArchiveFlag = 1 ;

				// fBNgƓ̂cw`t@CJ炻̒w̃t@CǂݍƂ
				if( DXA_STREAM_Initialize( &file->DXAStream, &DXARCD.Archive[ file->UseArchiveIndex ]->Archive, DxaInFilePath, UseASyncReadFlag ) < 0 )
				{
					_STRCPY( DXAErrorStr, DXSTRING( "cw`t@C̒Ɏw̃t@C͌܂ł\n" ) ) ;
					DXA_DIR_CloseArchive( file->UseArchiveIndex ) ;
					goto ERR ;
				}
			}
			else
			{
				// G[
				goto ERR;
			}
		}
	}

	// nh̐𑝂₷
	DXARCD.FileNum ++ ;

	// NeBJZNV̉
	CriticalSection_Unlock( &DXARCD.CriticalSection ) ;

	// CfbNXԂ
	return index | 0xF0000000 ;

ERR:
	// ̉
	if( DXARCD.File[index] != NULL ) DXFREE( DXARCD.File[index] ) ;
	DXARCD.File[index] = NULL ;
	
	// G[o
//	DXST_ERRORLOGFMT_ADD(( "t@C %s ̃I[vɎs܂\n", FilePath )) ;
//	if( DXAErrorStr[0] != '\0' ) DXST_ERRORLOGFMT_ADD(( "cw`G[F%s", DXAErrorStr )) ;

	// NeBJZNV̉
	CriticalSection_Unlock( &DXARCD.CriticalSection ) ;

	// G[I
	return 0 ;
}

// t@C
extern int DXA_DIR_Close( DWORD_PTR Handle )
{
	// NeBJZNV̎擾
	CRITICALSECTION_LOCK( &DXARCD.CriticalSection ) ;

	DXARC_DIR_FILE *file = DXARCD.File[Handle & 0x0FFFFFFF] ;

	// gpĂȂ牽I
	if( file == NULL )
	{
		// NeBJZNV̉
		CriticalSection_Unlock( &DXARCD.CriticalSection ) ;

		return -1 ;
	}
	
	// A[JCugpĂ邩ǂŕ
	if( file->UseArchiveFlag == FALSE )
	{
		// gpĂȂꍇ͕Wo͂̃t@C|C^
		ReadOnlyFileAccessClose( file->WinFilePointer_ ) ;
		file->WinFilePointer_ = 0 ;
	}
	else
	{
		// A[JCugpĂꍇ̓A[JCu̎QƐ炷
		
		// A[JCut@C̎QƐ炷
		DXA_DIR_CloseArchive( file->UseArchiveIndex ) ;

		// A[JCut@Čn
		DXA_STREAM_Terminate( &file->DXAStream ) ;
	}

	// 
	DXFREE( file ) ;
	DXARCD.File[Handle & 0x0FFFFFFF] = NULL ;
	
	// 炷
	DXARCD.FileNum -- ;

	// NeBJZNV̉
	CriticalSection_Unlock( &DXARCD.CriticalSection ) ;

	// I
	return 0 ;
}

// t@C|C^̈ʒu擾
extern	LONGLONG DXA_DIR_Tell( DWORD_PTR Handle )
{
	DXARC_DIR_FILE *file = DXARCD.File[Handle & 0x0FFFFFFF] ;
	if( file == NULL ) return -1 ;
	if( file->UseArchiveFlag == 0 )	return ReadOnlyFileAccessTell( file->WinFilePointer_ ) ;
	else							return DXA_STREAM_Tell( &file->DXAStream ) ;
}

// t@C|C^̈ʒuύX
extern int DXA_DIR_Seek( DWORD_PTR Handle, LONGLONG SeekPoint, int SeekType )
{
	DXARC_DIR_FILE *file = DXARCD.File[Handle & 0x0FFFFFFF] ;
	if( file == NULL ) return -1 ;
	if( file->UseArchiveFlag == 0 )	return ReadOnlyFileAccessSeek( file->WinFilePointer_, SeekPoint, SeekType ) ;
	else							return DXA_STREAM_Seek( &file->DXAStream, SeekPoint, SeekType ) ;
}

// t@Cf[^ǂݍ
extern size_t DXA_DIR_Read( void *Buffer, size_t BlockSize, size_t BlockNum, DWORD_PTR Handle )
{
	DXARC_DIR_FILE *file = DXARCD.File[Handle & 0x0FFFFFFF] ;
	if( file == NULL ) return ( size_t )-1 ;
	if( file->UseArchiveFlag == 0 )	return ReadOnlyFileAccessRead( Buffer, BlockSize, BlockNum, file->WinFilePointer_ ) ;
	else							return DXA_STREAM_Read( &file->DXAStream, Buffer, BlockSize * BlockNum ) / BlockSize ;
}

// t@C̏I[𒲂ׂ
extern int DXA_DIR_Eof( DWORD_PTR Handle )
{
	DXARC_DIR_FILE *file = DXARCD.File[Handle & 0x0FFFFFFF] ;
	if( file == NULL ) return -1 ;
	if( file->UseArchiveFlag == 0 ) return ReadOnlyFileAccessEof( file->WinFilePointer_ ) ;
	else							return DXA_STREAM_Eof( &file->DXAStream ) ;
}

extern	int DXA_DIR_ChDir( const TCHAR *Path )
{
	::SetCurrentDirectory( Path ) ;

	return 0 ;
}

extern	int DXA_DIR_GetDir( TCHAR *Buffer )
{
	::GetCurrentDirectory( 256, Buffer ) ;

	return 0 ;
}


extern	int DXA_DIR_IdleCheck( DWORD_PTR Handle )
{
	DXARC_DIR_FILE *file = DXARCD.File[Handle & 0x0FFFFFFF] ;
	if( file == NULL ) return -1 ;
	if( file->UseArchiveFlag == 0 )	return ReadOnlyFileAccessIdleCheck( file->WinFilePointer_ ) ;
	else							return DXA_STREAM_IdleCheck( &file->DXAStream ) ;
}

// ߂l: -1=G[  -1ȊO=FindHandle
extern DWORD_PTR DXA_DIR_FindFirst( const TCHAR *FilePath, FILEINFO *Buffer )
{
	DXA_DIR_FINDDATA *find;
	char nPath[256];

	// ̊m
	find = ( DXA_DIR_FINDDATA * )DXALLOC( sizeof( DXA_DIR_FINDDATA ) );
	if( find == NULL ) return ( DWORD_PTR )-1;
	_MEMSET( find, 0, sizeof( *find ) );

	// w̃IuWFNgA[JCut@Cׂ
	if( DXA_DIR_OpenTest( FilePath, &find->UseArchiveIndex, NULL, nPath ) == -1 )
	{
		// A[JCut@Cł͂Ȃꍇ̓t@C猟
		find->UseArchiveFlag = 0;
		find->FindHandle = ReadOnlyFileAccessFindFirst( FilePath, Buffer );
	}
	else
	{
		// A[JCut@C̏ꍇ̓A[JCut@C猟
		find->UseArchiveFlag = 1;
		find->FindHandle = DXA_FindFirst( &DXARCD.Archive[ find->UseArchiveIndex ]->Archive, nPath, Buffer );
	}

	// nh擾łȂꍇ̓G[
	if( find->FindHandle == ( DWORD_PTR )-1 )
	{
		DXFREE( find );
		return ( DWORD_PTR )-1;
	}

	// nhԂ
	return (DWORD_PTR)find;
}

// ߂l: -1=G[  0=
extern int DXA_DIR_FindNext( DWORD_PTR FindHandle, FILEINFO *Buffer )
{
	DXA_DIR_FINDDATA *find;

	find = (DXA_DIR_FINDDATA *)FindHandle;
	if( find->UseArchiveFlag == 0 )
		return ReadOnlyFileAccessFindNext( find->FindHandle, Buffer );
	else
		return DXA_FindNext( find->FindHandle, Buffer );
}

// ߂l: -1=G[  0=
extern int DXA_DIR_FindClose( DWORD_PTR FindHandle )
{
	DXA_DIR_FINDDATA *find;

	find = (DXA_DIR_FINDDATA *)FindHandle;
	if( find->UseArchiveFlag == 0 )
	{
		ReadOnlyFileAccessFindClose( find->FindHandle );
	}
	else
	{
		DXA_FindClose( find->FindHandle );
		DXA_DIR_CloseArchive( find->UseArchiveIndex ) ;
	}

	DXFREE( find );

	return 0;
}




// ŵcw`t@Cۂƃɓǂݍ( ߂l: -1=G[  0= )
extern int NS_DXArchivePreLoad( const TCHAR *FilePath , int ASyncThread )
{
	TCHAR fullpath[256];

	// tpX𓾂(łɑSĂ̕啶ɂ)
	DXA_DIR_ConvertFullPath( FilePath, fullpath ) ;

	return DXA_DIR_OpenArchive( fullpath, -1, TRUE, ASyncThread ) == -1 ? -1 : 0;
}

// ŵcw`t@C̎Oǂݍ݂ǂ擾( ߂lF TRUE= FALSE=܂ )
extern int NS_DXArchiveCheckIdle( const TCHAR *FilePath )
{
	int handle;
	TCHAR fullpath[256];

	// tpX𓾂(łɑSĂ̕啶ɂ)
	DXA_DIR_ConvertFullPath( FilePath, fullpath ) ;

	// t@CpXnh擾
	handle = DXA_DIR_GetArchive( fullpath );
	if( handle == -1 ) return 0 ;

	// ǂ𓾂
	return DXA_CheckIdle( &DXARCD.Archive[handle]->Archive );
}

// ŵcw`t@C
extern int NS_DXArchiveRelease( const TCHAR *FilePath )
{
	int handle;
	TCHAR fullpath[256];

	// tpX𓾂(łɑSĂ̕啶ɂ)
	DXA_DIR_ConvertFullPath( FilePath, fullpath ) ;

	// t@CpXnh擾
	handle = DXA_DIR_GetArchive( fullpath );
	if( handle == -1 ) return 0 ;

	// 
	DXA_DIR_CloseArchive( handle ) ;
	DXA_DIR_CloseWaitArchive() ;

	// I
	return 0 ;
}

// cw`t@C̒Ɏw̃t@C݂邩ǂ𒲂ׂATargetFilePath ͂cw`t@CJgtH_Ƃꍇ̃pX( ߂l:  -1=G[  0:  1: )
extern int NS_DXArchiveCheckFile( const TCHAR *FilePath, const TCHAR *TargetFilePath )
{
	int index, ret ;
	DXARC_DIR_ARCHIVE *Archive ;
	TCHAR fullpath[256];

	// tpX𓾂(łɑSĂ̕啶ɂ)
	DXA_DIR_ConvertFullPath( FilePath, fullpath ) ;

	// A[JCut@C邩ǂׂ
	index = DXA_DIR_OpenArchive( FilePath ) ;
	if( index == -1 ) return -1 ;

	// A[JCu̒Ɏw̃t@C邩ǂ𒲂ׂ
	Archive = DXARCD.Archive[ index ] ;

#ifdef UNICODE
	// }`oCgɕϊ
	char TargetFilePathA[1024];
	WCharToMBChar( Archive->Archive.HeadV5.CodePage == 0 ? _GET_CODEPAGE() : Archive->Archive.HeadV5.CodePage, ( DXWCHAR * )TargetFilePath, TargetFilePathA, 256 ) ;
	ret = DXA_GetFileInfo( &Archive->Archive, TargetFilePathA, NULL, NULL ) ;
#else
	ret = DXA_GetFileInfo( &Archive->Archive, TargetFilePath, NULL, NULL ) ;
#endif

	DXA_DIR_CloseArchive( index ) ;

	// ʂԂ
	return ret == -1 ? 0 : 1 ;
}

#endif


// f[^𓀂( ߂l:𓀌̃f[^TCY )
#define MIN_COMPRESS		(4)						// ŒሳkoCg
#define MAX_SEARCHLISTNUM	(64)					// ővTׂ̃XgHő吔
#define MAX_SUBLISTNUM		(65536)					// kԒZk̂߂̃TuXg̍ő吔
#define MAX_COPYSIZE 		(0x1fff + MIN_COMPRESS)	// QƃAhXRs[o؂őTCY( kR[h\łRs[TCY̍ől + ŒሳkoCg )
#define MAX_ADDRESSLISTNUM	(1024 * 1024 * 1)		// XCh̍őTCY
#define MAX_POSITION		(1 << 24)				// QƉ\ȍő告΃AhX( 16MB )

// kԒZkpXg
typedef struct LZ_LIST
{
	LZ_LIST *next, *prev ;
	DWORD address ;
} LZ_LIST ;

// f[^k( ߂l:k̃f[^TCY )
extern	int	DXA_Encode( void *Src, DWORD SrcSize, void *Dest )
{
	int dstsize ;
	int    bonus,    conbo,    conbosize,    address,    addresssize ;
	int maxbonus, maxconbo, maxconbosize, maxaddress, maxaddresssize ;
	BYTE keycode, *srcp, *destp, *dp, *sp, *sp2, *sp1 ;
	DWORD srcaddress, nextprintaddress, code ;
	int j ;
	DWORD i, m ;
	DWORD maxlistnum, maxlistnummask, listaddp ;
	DWORD sublistnum, sublistmaxnum ;
	LZ_LIST *listbuf, *listtemp, *list, *newlist ;
	BYTE *listfirsttable, *usesublistflagtable, *sublistbuf ;
	
	// TuXg̃TCY߂
	{
			 if( SrcSize < 100 * 1024 )			sublistmaxnum = 1 ;
		else if( SrcSize < 3 * 1024 * 1024 )	sublistmaxnum = MAX_SUBLISTNUM / 3 ;
		else									sublistmaxnum = MAX_SUBLISTNUM ;
	}

	// Xg̃TCY߂
	{
		maxlistnum = MAX_ADDRESSLISTNUM ;
		if( maxlistnum > SrcSize )
		{
			while( ( maxlistnum >> 1 ) > 0x100 && ( maxlistnum >> 1 ) > SrcSize )
				maxlistnum >>= 1 ;
		}
		maxlistnummask = maxlistnum - 1 ;
	}

	// ̊m
	usesublistflagtable   = (BYTE *)DXALLOC(
		sizeof( DWORD_PTR )	* 65536 +					// CXg̐擪IuWFNgp̈
		sizeof( LZ_LIST   )	* maxlistnum +				// CXgp̈
		sizeof( BYTE      )	* 65536 +					// TuXggpĂ邩tOp̈
		sizeof( DWORD_PTR )	* 256 * sublistmaxnum ) ;	// TuXgp̈
		
	// AhX̃Zbg
	listfirsttable =     usesublistflagtable + sizeof( BYTE      ) * 65536 ;
	sublistbuf     =          listfirsttable + sizeof( DWORD_PTR ) * 65536 ;
	listbuf        = (LZ_LIST *)( sublistbuf + sizeof( DWORD_PTR ) * 256 * sublistmaxnum ) ;
	
	// 
	_MEMSET( usesublistflagtable, 0, sizeof( BYTE      ) * 65536               ) ;
	_MEMSET(          sublistbuf, 0, sizeof( DWORD_PTR ) * 256 * sublistmaxnum ) ;
	_MEMSET(      listfirsttable, 0, sizeof( DWORD_PTR ) * 65536               ) ;
	list = listbuf ;
	for( i = maxlistnum / 8 ; i ; i --, list += 8 )
	{
		list[0].address =
		list[1].address =
		list[2].address =
		list[3].address =
		list[4].address =
		list[5].address =
		list[6].address =
		list[7].address = 0xffffffff ;
	}

	srcp  = (BYTE *)Src ;
	destp = (BYTE *)Dest ;

	// kf[^̒ňԏopxႢoCgR[h
	{
		DWORD qnum, table[256], mincode ;

		for( i = 0 ; i < 256 ; i ++ )
			table[i] = 0 ;
		
		sp   = srcp ;
		qnum = SrcSize / 8 ;
		i    = qnum * 8 ;
		for( ; qnum ; qnum --, sp += 8 )
		{
			table[sp[0]] ++ ;
			table[sp[1]] ++ ;
			table[sp[2]] ++ ;
			table[sp[3]] ++ ;
			table[sp[4]] ++ ;
			table[sp[5]] ++ ;
			table[sp[6]] ++ ;
			table[sp[7]] ++ ;
		}
		for( ; i < SrcSize ; i ++, sp ++ )
			table[*sp] ++ ;
			
		keycode = 0 ;
		mincode = table[0] ;
		for( i = 1 ; i < 256 ; i ++ )
		{
			if( mincode < table[i] ) continue ;
			mincode = table[i] ;
			keycode = (BYTE)i ;
		}
	}

	// k̃TCYZbg
	((DWORD *)destp)[0] = SrcSize ;

	// L[R[hZbg
	destp[8] = keycode ;

	// k
	dp               = destp + 9 ;
	sp               = srcp ;
	srcaddress       = 0 ;
	dstsize          = 0 ;
	listaddp         = 0 ;
	sublistnum       = 0 ;
	nextprintaddress = 1024 * 100 ;
	while( srcaddress < SrcSize )
	{
		// cTCYŒሳkTCYȉ̏ꍇ͈kȂ
		if( srcaddress + MIN_COMPRESS >= SrcSize ) goto NOENCODE ;

		// Xg擾
		code = *((WORD *)sp) ;
		list = (LZ_LIST *)( listfirsttable + code * sizeof( DWORD_PTR ) ) ;
		if( usesublistflagtable[code] == 1 )
		{
			list = (LZ_LIST *)( (DWORD_PTR *)list->next + sp[2] ) ;
		}
		else
		{
			if( sublistnum < sublistmaxnum )
			{
				list->next = (LZ_LIST *)( sublistbuf + sizeof( DWORD_PTR ) * 256 * sublistnum ) ;
				list       = (LZ_LIST *)( (DWORD_PTR *)list->next + sp[2] ) ;
			
				usesublistflagtable[code] = 1 ;
				sublistnum ++ ;
			}
		}

		// Ԉv̒R[hT
		maxconbo   = -1 ;
		maxaddress = -1 ;
		maxbonus   = -1 ;
		for( m = 0, listtemp = list->next ; /*m < MAX_SEARCHLISTNUM &&*/ listtemp != NULL ; listtemp = listtemp->next, m ++ )
		{
			address = srcaddress - listtemp->address ;
			if( address >= MAX_POSITION )
			{
				if( listtemp->prev ) listtemp->prev->next = listtemp->next ;
				if( listtemp->next ) listtemp->next->prev = listtemp->prev ;
				listtemp->address = 0xffffffff ;
				continue ;
			}
			
			sp2 = &sp[-address] ;
			sp1 = sp ;
			if( srcaddress + MAX_COPYSIZE < SrcSize )
			{
				conbo = MAX_COPYSIZE / 4 ;
				while( conbo && *((DWORD *)sp2) == *((DWORD *)sp1) )
				{
					sp2 += 4 ;
					sp1 += 4 ;
					conbo -- ;
				}
				conbo = MAX_COPYSIZE - ( MAX_COPYSIZE / 4 - conbo ) * 4 ;

				while( conbo && *sp2 == *sp1 )
				{
					sp2 ++ ;
					sp1 ++ ;
					conbo -- ;
				}
				conbo = MAX_COPYSIZE - conbo ;
			}
			else
			{
				for( conbo = 0 ;
						conbo < MAX_COPYSIZE &&
						conbo + srcaddress < SrcSize &&
						sp[conbo - address] == sp[conbo] ;
							conbo ++ ){}
			}

			if( conbo >= 4 )
			{
				conbosize   = ( conbo - MIN_COMPRESS ) < 0x20 ? 0 : 1 ;
				addresssize = address < 0x100 ? 0 : ( address < 0x10000 ? 1 : 2 ) ;
				bonus       = conbo - ( 3 + conbosize + addresssize ) ;

				if( bonus > maxbonus )
				{
					maxconbo       = conbo ;
					maxaddress     = address ;
					maxaddresssize = addresssize ;
					maxconbosize   = conbosize ;
					maxbonus       = bonus ;
				}
			}
		}

		// Xgɓo^
		newlist = &listbuf[listaddp] ;
		if( newlist->address != 0xffffffff )
		{
			if( newlist->prev ) newlist->prev->next = newlist->next ;
			if( newlist->next ) newlist->next->prev = newlist->prev ;
			newlist->address = 0xffffffff ;
		}
		newlist->address = srcaddress ;
		newlist->prev    = list ;
		newlist->next    = list->next ;
		if( list->next != NULL ) list->next->prev = newlist ;
		list->next       = newlist ;
		listaddp         = ( listaddp + 1 ) & maxlistnummask ;

		// vR[hȂ񈳏kR[hƂďo
		if( maxconbo == -1 )
		{
NOENCODE:
			// L[R[hꍇ͂QAŏo͂
			if( *sp == keycode )
			{
				if( destp != NULL )
				{
					dp[0]  =
					dp[1]  = keycode ;
					dp += 2 ;
				}
				dstsize += 2 ;
			}
			else
			{
				if( destp != NULL )
				{
					*dp = *sp ;
					dp ++ ;
				}
				dstsize ++ ;
			}
			sp ++ ;
			srcaddress ++ ;
		}
		else
		{
			// ꍇ͌ʒuƒo͂
			
			// L[R[hƌʒuƒo
			if( destp != NULL )
			{
				// L[R[h̏o
				*dp++ = keycode ;

				// o͂A͍Œ MIN_COMPRESS 邱ƂOȂ̂ - MIN_COMPRESS ̂o͂
				maxconbo -= MIN_COMPRESS ;

				// AO`SrbgƘAA΃AhX̃rbgo
				*dp = (BYTE)( ( ( maxconbo & 0x1f ) << 3 ) | ( maxconbosize << 2 ) | maxaddresssize ) ;

				// L[R[h̘A̓L[R[hƒl̓񈳏kR[h
				// f邽߁AL[R[h̒lȏ̏ꍇ͒l{P
				if( *dp >= keycode ) dp[0] += 1 ;
				dp ++ ;

				// AT`PQrbgo
				if( maxconbosize == 1 )
					*dp++ = (BYTE)( ( maxconbo >> 5 ) & 0xff ) ;

				// maxconbo ͂܂g - MIN_COMPRESS ߂
				maxconbo += MIN_COMPRESS ;

				// o͂鑊΃AhX͂O( ݂̃AhX|P )}̂ŁA|P̂o͂
				maxaddress -- ;

				// ΃AhXo
				*dp++ = (BYTE)( maxaddress ) ;
				if( maxaddresssize > 0 )
				{
					*dp++ = (BYTE)( maxaddress >> 8 ) ;
					if( maxaddresssize == 2 )
						*dp++ = (BYTE)( maxaddress >> 16 ) ;
				}
			}
			
			// o̓TCYZ
			dstsize += 3 + maxaddresssize + maxconbosize ;
			
			// Xgɏǉ
			if( srcaddress + maxconbo < SrcSize )
			{
				sp2 = &sp[1] ;
				for( j = 1 ; j < maxconbo && (DWORD_PTR)&sp2[2] - (DWORD_PTR)srcp < SrcSize ; j ++, sp2 ++ )
				{
					code = *((WORD *)sp2) ;
					list = (LZ_LIST *)( listfirsttable + code * sizeof( DWORD_PTR ) ) ;
					if( usesublistflagtable[code] == 1 )
					{
						list = (LZ_LIST *)( (DWORD_PTR *)list->next + sp2[2] ) ;
					}
					else
					{
						if( sublistnum < sublistmaxnum )
						{
							list->next = (LZ_LIST *)( sublistbuf + sizeof( DWORD_PTR ) * 256 * sublistnum ) ;
							list       = (LZ_LIST *)( (DWORD_PTR *)list->next + sp2[2] ) ;
						
							usesublistflagtable[code] = 1 ;
							sublistnum ++ ;
						}
					}

					newlist = &listbuf[listaddp] ;
					if( newlist->address != 0xffffffff )
					{
						if( newlist->prev ) newlist->prev->next = newlist->next ;
						if( newlist->next ) newlist->next->prev = newlist->prev ;
						newlist->address = 0xffffffff ;
					}
					newlist->address = srcaddress + j ;
					newlist->prev = list ;
					newlist->next = list->next ;
					if( list->next != NULL ) list->next->prev = newlist ;
					list->next = newlist ;
					listaddp = ( listaddp + 1 ) & maxlistnummask ;
				}
			}
			
			sp         += maxconbo ;
			srcaddress += maxconbo ;
		}
	}

	// k̃f[^TCYۑ
	*((DWORD *)&destp[4]) = dstsize + 9 ;

	// mۂ̉
	DXFREE( usesublistflagtable ) ;

	// f[^̃TCYԂ
	return dstsize + 9 ;
}

extern int DXA_Decode( void *Src, void *Dest )
{
	DWORD srcsize, destsize, code, indexsize, keycode, conbo, index = 0 ;
	BYTE *srcp, *destp, *dp, *sp ;

	destp = (BYTE *)Dest ;
	srcp  = (BYTE *)Src ;
	
	// 𓀌̃f[^TCY𓾂
	destsize = *((DWORD *)&srcp[0]) ;

	// kf[^̃TCY𓾂
	srcsize = *((DWORD *)&srcp[4]) - 9 ;

	// L[R[h
	keycode = srcp[8] ;
	
	// o͐悪Ȃꍇ̓TCYԂ
	if( Dest == NULL )
		return destsize ;
	
	// WJJn
	sp  = srcp + 9 ;
	dp  = destp ;
	while( srcsize )
	{
		// L[R[hŏ𕪊
		if( sp[0] != keycode )
		{
			// 񈳏kR[h̏ꍇ͂̂܂܏o
			*dp = *sp ;
			dp      ++ ;
			sp      ++ ;
			srcsize -- ;
			continue ;
		}
	
		// L[R[hAĂꍇ̓L[R[ĥo
		if( sp[1] == keycode )
		{
			*dp = (BYTE)keycode ;
			dp      ++ ;
			sp      += 2 ;
			srcsize -= 2 ;
			
			continue ;
		}

		// oCg𓾂
		code = sp[1] ;

		// L[R[h傫Ȓlꍇ̓L[R[h
		// Ƃ̃obeBOh~ׂ̈Ɂ{PĂ̂Ł|P
		if( code > keycode ) code -- ;

		sp      += 2 ;
		srcsize -= 2 ;

		// A擾
		conbo = code >> 3 ;
		if( code & ( 0x1 << 2 ) )
		{
			conbo |= *sp << 5 ;
			sp      ++ ;
			srcsize -- ;
		}
		conbo += MIN_COMPRESS ;	// ۑɌZŏkoCg𑫂

		// QƑ΃AhX擾
		indexsize = code & 0x3 ;
		switch( indexsize )
		{
		case 0 :
			index = *sp ;
			sp      ++ ;
			srcsize -- ;
			break ;
			
		case 1 :
			index = *((WORD *)sp) ;
			sp      += 2 ;
			srcsize -= 2 ;
			break ;
			
		case 2 :
			index = *((WORD *)sp) | ( sp[2] << 16 ) ;
			sp      += 3 ;
			srcsize -= 3 ;
			break ;
		}
		index ++ ;		// ۑɁ|PĂ̂Ł{P

		// WJ
		if( index < conbo )
		{
			DWORD num ;

			num  = index ;
			while( conbo > num )
			{
				_MEMCPY( dp, dp - num, num ) ;
				dp    += num ;
				conbo -= num ;
				num   += num ;
			}
			if( conbo != 0 )
			{
				_MEMCPY( dp, dp - num, conbo ) ;
				dp += conbo ;
			}
		}
		else
		{
			_MEMCPY( dp, dp - index, conbo ) ;
			dp += conbo ;
		}
	}

	// 𓀌̃TCYԂ
	return (int)destsize ;
}

}
