// -------------------------------------------------------------------------------
// 
// 		cwCu		tHgpvOwb_t@C
// 
// 				Ver 3.11d
// 
// -------------------------------------------------------------------------------

#ifndef __DXFONT_H__
#define __DXFONT_H__

#include "DxCompileConfig.h"

#ifndef DX_NON_FONT

// CN[h ------------------------------------------------------------------
#include "DxLib.h"
#include "DxStatic.h"
#include "DxMemImg.h"
#include "DxHandle.h"

namespace DxLib
{

// }N` --------------------------------------------------------------------

// \̒` --------------------------------------------------------------------

// CreateFontToHandle ŎgpO[oϐZ߂
struct CREATEFONTTOHANDLE_GPARAM
{
	int						NotTextureFlag ;					// 쐬tHgLbVeNX`ɂ邩AtO
	int						TextureCacheColorBitDepth16Flag ;	// 쐬tHgLbVeNX`̃J[rbg16rbgɂ邩ǂ̃tO
	int						CacheCharNum ;						// tHgLbVŃLbVł镶̐
	int						UsePremulAlphaFlag ;				// Zς݃gp邩ǂ̃tO( TRUE:gp  FALSE:gpȂ )
} ;

// tHgP̃LbV
struct FONTDATA
{
	BYTE					ValidFlag ;			// LtO
	BYTE					WCharaFlag ;		// ChtO
	short					DrawX, DrawY ;		// 摜`悷ׂW
	short					AddX ;				// ̕`悷ׂ΍W
	int						GraphIndex ;		// f[^̃CfbNXio[
	short					SizeX, SizeY ;		// ̃TCY
	struct FONTCODEDATA *	CodeData ;			// ̃tHgǗĂf[^̃|C^
} ;

// tHgLbV݃tO\
struct FONTCODEDATA
{
	int						ExistFlag ;			// LbV̑݃tO
	FONTDATA *				DataPoint ;			// LbVf[^݈̑ʒu
} ;

// tHgLbV̊Ǘf[^
struct FONTMANAGE
{
	HANDLEINFO				HandleInfo ;						// nhʃf[^

	int						UseTextOut ;						// TextOut gp^CṽtHgǂ( TRUE:TextOutgp  FALSE:GetGlyphOutline gp )

	HBITMAP					CacheBitmap ;						// eLXgLbVprbg}bv
	unsigned char			*CacheBitmapMem ;					// eLXgLbVprbg}bṽ
	int						CacheBitmapMemPitch ;				// eLXgLbVprbg}bṽsb`

	int						*LostFlag ;							//  TRUE ɂtOւ̃|C^

	FONTDATA				FontData[ FONT_CACHE_MAXNUM + 1 ];	// LbVf[^
	FONTCODEDATA			FontCodeData[ 0x10000 ] ;			// ݃f[^܂ރf[^z
	unsigned int			Index ;								// f[^ǉ̔zCfbNXio[
	int						MaxCacheCharNum ;					// LbVłő吔
	unsigned char			*CacheMem ;							// eLXgLbV
	int						CachePitch ;						// eLXgLbṼsb`	
	int						CacheDataBitNum ;					// eLXgLbV̂PsNZ̃rbg

	TCHAR					FontName[ 256 ] ;					// tHg̖O
	int						FontThickness ;						// tHg̑
	int						FontSize ;							// `悷tHg̃TCY
	int						FontHeight ;						// `悷tHg̍őc
	int						FontAddHeight ;						// TCŸׂɑ
	int						Italic ;							// C^bNtHgǂ(TRUE:C^bN FALSE:C^bN)
	int						Space ;								// ̕\WɉZhbg
	int						MaxWidth ;							// tHg̍ő啝
	HFONT					FontObj ;							// tHg̃IuWFNgf[^

	int						FontType ;							// tHg̃^Cv
	int						CharSet ;							// LN^Zbg
	int						EdgeSize ;							// GbW̑

	SIZE					SurfaceSize ;						// eLXgT[tFX̃TCY 
	int						LengthCharNum ;						// T[tFX̏cɕׂ镶̐

	int						TextureCache ;						// eNX`ɃLbVꍇ̃eNX`OtBbNnh
	int						TextureCacheSub ;					// eNX`ɃLbVꍇ̃eNX`OtBbNnh(p)
	int						TextureCacheLostFlag ;				// TextureCache ɂȂƂ TRUE ɂȂϐ
//	BASEIMAGE				TextureTempCache ;					// eNX`ɓ]OɈꎞIɃOtBbNf[^ۑC[Wf[^
	BASEIMAGE				TextureCacheBaseImage ;				// TextureCache ɓ]̂Ɠ̂i[{C[W
	int						TextureCacheColorBitDepth ;			// eNX`LbṼJ[rbg
	int						TextureCacheUsePremulAlpha ;		// eNX`LbṼ`lZς݃ɂ邩ǂ

	int						TextureCacheFlag ;					// eNX`LbVĂ邩AtO
} ;

// tHgVXep\
struct FONTSYSTEM
{
	int						InitializeFlag ;					// tO

	int						NotTextureFlag ;					// 쐬tHgLbVeNX`ɂ邩AtO
	int						TextureCacheColorBitDepth16Flag ;	// 쐬tHgLbVeNX`̃J[rbg16rbgɂ邩ǂ̃tO
	int						CacheCharNum ;						// tHgLbVŃLbVł镶̐
	int						UsePremulAlphaFlag ;				// Zς݃gp邩ǂ̃tO( TRUE:gp  FALSE:gpȂ )
	BYTE					BitCountTable[ 256 ] ;				// rbgJEge[u

	int						DefaultFontHandle ;					// ftHgŎgptHg̃nh
	TCHAR					DefaultFontName[ 128 ] ;			// ftHgŎgptHg̐ݒ
	int						DefaultFontSize ;
	int						DefaultFontThick ;
	int						DefaultFontType ;
	int						DefaultFontCharSet ;
	int						DefaultFontEdgeSize ;
	int						DefaultFontItalic ;
	int						DefaultFontSpace ;
} ;

// e[u-----------------------------------------------------------------------

// ϐ錾 --------------------------------------------------------------

// ֐vg^Cv錾-----------------------------------------------------------

extern	int			InitFontManage( void ) ;																					// tHgVXȅ
extern	int			TermFontManage( void ) ;																					// tHg̏I
extern	int			InitCacheFontToHandle( void ) ;																				// tHg̃LbV
extern	int			InitFontCacheToHandle( int FontHandle, int ASyncThread = FALSE ) ;											// ̃tHg̃LbV

extern	int			InitializeFontHandle( HANDLEINFO *HandleInfo ) ;															// tHgnh
extern	int			TerminateFontHandle( HANDLEINFO *HandleInfo ) ;																// tHgnȟn

extern	int			RefreshFontDrawResourceToHandle( int FontHandle, int ASyncThread = FALSE ) ;								// tHgnhgp`obt@eNX`LbVď
extern	int			FontCacheStringDrawToHandleST(
							int DrawFlag, int x, int y, 
							bool ExRateValidFlag, double ExRateX, double ExRateY,
							const TCHAR *StrData,
							int Color, MEMIMG *DestMemImg, const RECT *ClipRect,
							int TransFlag, int FontHandle, int EdgeColor,
							int StrLen, int VerticalFlag, SIZE *DrawSize ) ;
extern	int			RefreshDefaultFont( void ) ;																				// ftHgtHgč쐬
extern	int			InitFontToHandleBase( int Terminate = FALSE ) ;																// InitFontToHandle ̓֐
/*
extern	int			FontCacheStringDrawToHandleST(  int DrawFlag, int x, int y, const char *StrData, int Color, void *DSuf,
													void *ASuf, int APitch, RECT *ClipRect, int ColorBitDepth ,
													int TransFlag, int FontHandle, int EdgeColor, int StrLen, int VerticalFlag,
													SIZE *DrawSize ) ;															// ̕`iLbVgpŁj
*/

extern	FONTMANAGE *GetFontManageDataToHandle( int FontHandle ) ;																// tHgǗf[^̎擾

extern	void		InitCreateFontToHandleGParam( CREATEFONTTOHANDLE_GPARAM *GParam ) ;											// CREATEFONTTOHANDLE_GPARAM ̃f[^Zbg

extern	int			CreateFontToHandle_UseGParam( CREATEFONTTOHANDLE_GPARAM *GParam, const TCHAR *FontName, int Size, int Thick, int FontType, int CharSet, int EdgeSize, int Italic, int Handle, int ASyncLoadFlag = FALSE ) ;			// CreateFontToHandle ̃O[oϐɃANZXȂo[W

}

#endif // DX_NON_FONT

#endif // __DXFONT_H__
